if (MODID == 18 and MODVERSION < 52)
	error("Please update SRB2! Gamma is not compatible with versions older than 2.2.11.");
	return;
end

if (Gamma != nil)
	-- Multiple Gammas loaded?
	error("Gamma was already loaded.");
	return;
end

// Library / dependencies
dofile("lib/customhud.lua");
dofile("lib/vectorlib.lua");

// Important definitions
dofile("definitions.lua");

// Init hook system
dofile("hooks.lua");

// Object hooking
dofile("mobj/edits-base.lua"); // Vanilla object edits
dofile("mobj/edits-thz.lua");
dofile("mobj/edits-dsz.lua");
dofile("mobj/edits-cez.lua");
dofile("mobj/edits-acz.lua");
dofile("mobj/edits-hhz.lua");
dofile("mobj/edits-fhz.lua");
dofile("mobj/edits-atz.lua");
dofile("mobj/edits-stalagmite.lua");
dofile("mobj/edits-disco.lua");
dofile("mobj/edits-xmas.lua");
dofile("mobj/edits-mario.lua");
dofile("mobj/custom.lua"); // Custom object examples

// Abilty functions
dofile("ability/shoot.lua");
dofile("ability/blaster.lua");
dofile("ability/aim.lua");
dofile("ability/jet.lua");
dofile("ability/drive.lua");
dofile("ability/coop.lua");

// Animation systems
dofile("anim/partdefs.lua");
dofile("anim/animationdefs.lua");
dofile("anim/animator.lua");
dofile("anim/ghosts.lua");

// Special EFX functions
dofile("efx/shot.lua");
dofile("efx/laser.lua");
dofile("efx/target.lua");
dofile("efx/jet.lua");
dofile("efx/coop.lua");
dofile("efx/blaster.lua");
dofile("efx/dust.lua");
dofile("efx/sfx.lua");

// Timer system functions
dofile("time.lua");

// Extra Smart Tether support
dofile("tether.lua");

// Extra Battle support
dofile("battle.lua");

// Main gameplay loop
dofile("main.lua");

// Main HUD loop
dofile("hud.lua");
