Gamma.DefaultGammaCoopJumpVars = function(player)
	if not (player.mo and player.mo.valid)
		return;
	end

	player.mo.gammaCoopJump = {
		active = false,
		ready = false,
		used = false,
		state = 0,
		glow = nil,
		oldJump = player.jumpfactor,
		origin = nil,
	}
end

Gamma.CoopJumpLogic = function(player)
	local onGround = P_IsObjectOnGround(player.mo);

	if (player.mo.gammaCoopJump == nil)
		Gamma.DefaultGammaCoopJumpVars(player);
	end

	if (onGround == true)
		player.mo.gammaCoopJump.used = false;
	elseif (player.mo.gammaCoopJump.used == true)
		local xydist = P_AproxDistance(player.mo.momx, player.mo.momy);
		local zdist = player.mo.momz;
		local speed = FixedHypot(xydist, zdist);

		local hAngle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy);
		local vAngle = R_PointToAngle2(0, 0, xydist, zdist);

		/*
		local baseRad = FixedDiv(player.mo.radius, player.mo.scale)
		local xOffset = FixedMul(baseRad, cos(hAngle + ANGLE_90))
		local yOffset = FixedMul(baseRad, sin(hAngle + ANGLE_90))
		*/
		local zOffset = FixedDiv(player.mo.height, player.mo.scale) >> 1;

		Gamma.SpawnTrail(
			player.mo, speed, hAngle, vAngle,
			0, 0, zOffset
		);
	end

	local oldJump = skins[player.mo.skin].jumpfactor;

	if (player.mo.gammaCoopJump.active == true)
		if (player.mo.gammaCoopJump.ready == true)
		and (player.pflags & PF_JUMPED)
			// Spawn efx
			if (player.mo.gammaCoopJump.used == false)
				Gamma.SpawnJumpCircle(player.mo);
			end

			// Reset jump height back to normal
			player.jumpfactor = oldJump;
			player.gammaJumpSet = nil;

			player.mo.gammaCoopJump.active = false;
			player.mo.gammaCoopJump.used = true;
		else
			// Your next jump is boosted!!
			player.jumpfactor = FixedMul(oldJump, Gamma.WATERVAL);
			player.gammaJumpSet = true;

			Gamma.CoopJumpGlowCreate(player);

			if (onGround == true)
				player.mo.gammaCoopJump.ready = true;
			end
		end
	else
		// Store your normal jump height
		player.mo.gammaCoopJump.ready = false

		if (player.mo.gammaCoopJump.glow and player.mo.gammaCoopJump.glow.valid)
			P_RemoveMobj(player.mo.gammaCoopJump.glow)
		end
	end
end
