local GhostList = {};

addHook("MobjSpawn", function(ghost)
	if not (modeattacking and leveltime < 2)
		// not a time attack ghost
		return;
	end

	// insert into ghosts with animators list
	table.insert(GhostList, ghost);
end, MT_GHOST)

Gamma.RunGhost = function(ghost)
	if not (ghost.gammaFollow and ghost.gammaFollow.valid)
		// create an animator for the ghost
		ghost.gammaFollow = P_SpawnMobjFromMobj(ghost, 0, 0, 0, MT_GAMMA_ANIMATIONMASTER);
		ghost.gammaFollow.tracer = ghost;
		ghost.gammaFollow.flags2 = $1 | MF2_LINKDRAW;
		return;
	end

	// run the animator for the ghost
	Gamma.FollowMobj(ghost, ghost.gammaFollow);
	ghost.sprite2 = SPR2_STND;
end

local function IsGammaGhost(ghost)
	if (ghost.gammaFollow and ghost.gammaFollow.valid)
		-- We've already established this is definitely a gamma ghost
		return true;
	end

	return (ghost.skin == "gamma");
end

Gamma.RunRecordAttackGhosts = function()
	if not (modeattacking)
		// IGNORE
		return;
	end

	if (leveltime < 2)
		// wait a bit...
		return;
	end

	for k,ghost in pairs(GhostList) do
		if not (ghost and ghost.valid)
			table.remove(GhostList, k);
			continue;
		end

		if (IsGammaGhost(ghost) == false)
			-- Doesn't look like a gamma ghost
			table.remove(GhostList, k);
			continue;
		end

		Gamma.RunGhost(ghost);
	end
end
