Gamma.AnimPartIDs = {
	WAIST = 1,
	PROPELLER = 2,
	TORSO = 3,
	HEAD = 4,
	LASER = 5,
	UPPERLEG_L = 6,
	UPPERLEG_R = 7,
	MIDLEG_L = 8,
	MIDLEG_R = 9,
	LOWERLEG_L = 10,
	LOWERLEG_R = 11,
	FOOT_L = 12,
	FOOT_R = 13,
	UPPERARM_L = 14,
	UPPERARM_R = 15,
	MIDARM_L = 16,
	MIDARM_R = 17,
	LOWERARM_L = 18,
	LOWERARM_R = 19,
	JET = 20,
	SODA = 21,
	HAT = 22,
};

Gamma.AnimPartDefs = {
	head = {
		sprite = SPR2_PRTA,
		bright = SPR2_PBMA,
		frames = {
			// 1: bottom
			// 2: laser pointer
			// 3: hat
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 1, y = -17, z = 0},
					[3] = {x = 0, y = 0, z = 8},
				},
			},
			[1] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 1, y = -17, z = 0},
					[3] = {x = 0, y = 0, z = 8},
				},
			},
			[2] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 1, y = -17, z = 0},
					[3] = {x = 0, y = 0, z = 8},
				},
			},
		},
	},
	torso = {
		sprite = SPR2_PRTB,
		frames = {
			// 1: bottom
			// 2: arm
			// 3: arm
			// 4: neck
			// 5: jet booster
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 4, y = 25, z = 16},
					[3] = {x = 4, y = -25, z = 16},
					[4] = {x = -2, y = 0, z = 21},
					[5] = {x = -46, y = 0, z = 20},
				},
			},
			[1] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 6, y = 25, z = 14},
					[3] = {x = 6, y = -25, z = 14},
					[4] = {x = 2, y = 0, z = 20},
					[5] = {x = -40, y = 0, z = 36},
				},
			},
			[2] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 7, y = 25, z = 12},
					[3] = {x = 7, y = -25, z = 12},
					[4] = {x = 6, y = 0, z = 19},
					[5] = {x = -26, y = 0, z = 50},
				},
			},
		},
	},
	upperarm = {
		sprite = SPR2_PRTC,
		frames = {
			// 1: shoulder
			// 2: bottom
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = -4},
					[2] = {x = 0, y = 0, z = 18},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -2, y = 0, z = -3},
					[2] = {x = 6, y = 0, z = 16},
				},
			},
			[2] = {
				joints = {
					[1] = {x = -4, y = 0, z = 0},
					[2] = {x = 10, y = 0, z = 14},
				},
			},
			[3] = {
				joints = {
					[1] = {x = -6, y = 0, z = 1},
					[2] = {x = 12, y = 0, z = 10},
				},
			},
			[4] = {
				joints = {
					[1] = {x = -7, y = 0, z = 4},
					[2] = {x = 14, y = 0, z = 4},
				},
			},
			[5] = {
				joints = {
					[1] = {x = -6, y = 0, z = 7},
					[2] = {x = 12, y = 0, z = -2},
				},
			},
			[6] = {
				joints = {
					[1] = {x = -4, y = 0, z = 8},
					[2] = {x = 10, y = 0, z = -6},
				},
			},
			[7] = {
				joints = {
					[1] = {x = -2, y = 0, z = 11},
					[2] = {x = 6, y = 0, z = -8},
				},
			},
			[8] = {
				joints = {
					[1] = {x = 0, y = 0, z = 12},
					[2] = {x = 0, y = 0, z = -10},
				},
			},
			[9] = {
				joints = {
					[1] = {x = 2, y = 0, z = 11},
					[2] = {x = -6, y = 0, z = -8},
				},
			},
			[10] = {
				joints = {
					[1] = {x = 4, y = 0, z = 8},
					[2] = {x = -10, y = 0, z = -6},
				},
			},
			[11] = {
				joints = {
					[1] = {x = 6, y = 0, z = 7},
					[2] = {x = -12, y = 0, z = -2},
				},
			},
			[12] = {
				joints = {
					[1] = {x = 7, y = 0, z = 4},
					[2] = {x = -14, y = 0, z = 4},
				},
			},
		},
	},
	midarm = {
		sprite = SPR2_PRTL,
		frames = {
			// 1: top
			// 2: bottom
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = -7},
					[2] = {x = 0, y = 0, z = 11},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -4, y = 0, z = -6},
					[2] = {x = 4, y = 0, z = 10},
				},
			},
			[2] = {
				joints = {
					[1] = {x = -6, y = 0, z = -4},
					[2] = {x = 6, y = 0, z = 8},
				},
			},
			[3] = {
				joints = {
					[1] = {x = -8, y = 0, z = -2},
					[2] = {x = 8, y = 0, z = 6},
				},
			},
			[4] = {
				joints = {
					[1] = {x = -9, y = 0, z = 2},
					[2] = {x = 9, y = 0, z = 2},
				},
			},
			[5] = {
				joints = {
					[1] = {x = -8, y = 0, z = 4},
					[2] = {x = 8, y = 0, z = -4},
				},
			},
			[6] = {
				joints = {
					[1] = {x = -6, y = 0, z = 6},
					[2] = {x = 6, y = 0, z = -6},
				},
			},
			[7] = {
				joints = {
					[1] = {x = -4, y = 0, z = 8},
					[2] = {x = 4, y = 0, z = -8},
				},
			},
			[8] = {
				joints = {
					[1] = {x = 0, y = 0, z = 9},
					[2] = {x = 0, y = 0, z = -9},
				},
			},
			[9] = {
				joints = {
					[1] = {x = 4, y = 0, z = 8},
					[2] = {x = -4, y = 0, z = -8},
				},
			},
			[10] = {
				joints = {
					[1] = {x = 6, y = 0, z = 6},
					[2] = {x = -6, y = 0, z = -6},
				},
			},
			[11] = {
				joints = {
					[1] = {x = 8, y = 0, z = 4},
					[2] = {x = -8, y = 0, z = -4},
				},
			},
			[12] = {
				joints = {
					[1] = {x = 9, y = 0, z = 2},
					[2] = {x = -9, y = 0, z = 2},
				},
			},
		},
	},
	handarm = {
		sprite = SPR2_PRTD,
		frames = {
			// 1: top
			// 2: hand
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = -12},
					[2] = {x = 0, y = -8, z = 22},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -8, y = 0, z = -10},
					[2] = {x = 6, y = -8, z = 20},
				},
			},
			[2] = {
				joints = {
					[1] = {x = -14, y = 0, z = -8},
					[2] = {x = 10, y = -8, z = 16},
				},
			},
			[3] = {
				joints = {
					[1] = {x = -16, y = 0, z = -2},
					[2] = {x = 14, y = -8, z = 12},
				},
			},
			[4] = {
				joints = {
					[1] = {x = -20, y = 0, z = 6},
					[2] = {x = 16, y = -8, z = 6},
				},
			},
			[5] = {
				joints = {
					[1] = {x = -16, y = 0, z = 14},
					[2] = {x = 14, y = -8, z = 0},
				},
			},
			[6] = {
				joints = {
					[1] = {x = -14, y = 0, z = 20},
					[2] = {x = 10, y = -8, z = -4},
				},
			},
			[7] = {
				joints = {
					[1] = {x = -8, y = 0, z = 22},
					[2] = {x = 6, y = -8, z = -8},
				},
			},
			[8] = {
				joints = {
					[1] = {x = 0, y = 0, z = 24},
					[2] = {x = 0, y = -8, z = -10},
				},
			},
			[9] = {
				joints = {
					[1] = {x = 8, y = 0, z = 22},
					[2] = {x = -6, y = -8, z = -8},
				},
			},
			[10] = {
				joints = {
					[1] = {x = 14, y = 0, z = 20},
					[2] = {x = -10, y = -8, z = -4},
				},
			},
			[11] = {
				joints = {
					[1] = {x = 16, y = 0, z = 14},
					[2] = {x = -14, y = -8, z = 0},
				},
			},
			[12] = {
				joints = {
					[1] = {x = 20, y = 0, z = 6},
					[2] = {x = -16, y = -8, z = 6},
				},
			},
		},
	},
	gunarm = {
		sprite = SPR2_PRTE,
		frames = {
			// 1: top
			// 2: gun muzzle
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = -8},
					[2] = {x = 0, y = 0, z = 26},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -6, y = 0, z = -6},
					[2] = {x = 8, y = 0, z = 24},
				},
			},
			[2] = {
				joints = {
					[1] = {x = -12, y = 0, z = -4},
					[2] = {x = 14, y = 0, z = 22},
				},
			},
			[3] = {
				joints = {
					[1] = {x = -14, y = 0, z = 2},
					[2] = {x = 18, y = 0, z = 16},
				},
			},
			[4] = {
				joints = {
					[1] = {x = -16, y = 0, z = 9},
					[2] = {x = 20, y = 0, z = 9},
				},
			},
			[5] = {
				joints = {
					[1] = {x = -14, y = 0, z = 16},
					[2] = {x = 18, y = 0, z = 2},
				},
			},
			[6] = {
				joints = {
					[1] = {x = -12, y = 0, z = 22},
					[2] = {x = 14, y = 0, z = -4},
				},
			},
			[7] = {
				joints = {
					[1] = {x = -6, y = 0, z = 24},
					[2] = {x = 8, y = 0, z = -6},
				},
			},
			[8] = {
				joints = {
					[1] = {x = 0, y = 0, z = 26},
					[2] = {x = 0, y = 0, z = -8},
				},
			},
			[9] = {
				joints = {
					[1] = {x = 6, y = 0, z = 24},
					[2] = {x = -8, y = 0, z = -6},
				},
			},
			[10] = {
				joints = {
					[1] = {x = 12, y = 0, z = 22},
					[2] = {x = -14, y = 0, z = -4},
				},
			},
			[11] = {
				joints = {
					[1] = {x = 14, y = 0, z = 16},
					[2] = {x = -18, y = 0, z = 2},
				},
			},
			[12] = {
				joints = {
					[1] = {x = 16, y = 0, z = 9},
					[2] = {x = -20, y = 0, z = 9},
				},
			},
		},
	},
	supergunarm = {
		sprite = SPR2_PRTO,
		frames = {
			// 1: top
			// 2: gun muzzle
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = -6},
					[2] = {x = 0, y = 0, z = 32},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -6, y = 0, z = -4},
					[2] = {x = 8, y = 0, z = 30},
				},
			},
			[2] = {
				joints = {
					[1] = {x = -12, y = 0, z = -2},
					[2] = {x = 14, y = 0, z = 26},
				},
			},
			[3] = {
				joints = {
					[1] = {x = -16, y = 0, z = 4},
					[2] = {x = 18, y = 0, z = 20},
				},
			},
			[4] = {
				joints = {
					[1] = {x = -18, y = 0, z = 12},
					[2] = {x = 20, y = 0, z = 12},
				},
			},
			[5] = {
				joints = {
					[1] = {x = -14, y = 0, z = 18},
					[2] = {x = 20, y = 0, z = 4},
				},
			},
			[6] = {
				joints = {
					[1] = {x = -10, y = 0, z = 24},
					[2] = {x = 16, y = 0, z = -2},
				},
			},
			[7] = {
				joints = {
					[1] = {x = -6, y = 0, z = 28},
					[2] = {x = 10, y = 0, z = -6},
				},
			},
			[8] = {
				joints = {
					[1] = {x = 0, y = 0, z = 30},
					[2] = {x = 0, y = 0, z = -8},
				},
			},
			[9] = {
				joints = {
					[1] = {x = 8, y = 0, z = 28},
					[2] = {x = -4, y = 0, z = -6},
				},
			},
			[10] = {
				joints = {
					[1] = {x = 15, y = 0, z = 26},
					[2] = {x = -12, y = 0, z = -2},
				},
			},
			[11] = {
				joints = {
					[1] = {x = 19, y = 0, z = 20},
					[2] = {x = -16, y = 0, z = 6},
				},
			},
			[12] = {
				joints = {
					[1] = {x = 21, y = 0, z = 14},
					[2] = {x = -18, y = 0, z = 14},
				},
			},
		},
	},
	waist = {
		sprite = SPR2_PRTJ,
		bright = SPR2_PBMJ,
		frames = {
			// 1: top
			// 2: leg
			// 3: leg
			[0] = {
				joints = {
					[1] = {x = -2, y = 0, z = 11},
					[2] = {x = 2, y = 16, z = 8},
					[3] = {x = 2, y = -16, z = 8},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -1, y = 0, z = 12},
					[2] = {x = 0, y = 16, z = 8},
					[3] = {x = 0, y = -16, z = 8},
				},
			},
			[2] = {
				joints = {
					[1] = {x = 1, y = 0, z = 13},
					[2] = {x = -2, y = 16, z = 8},
					[3] = {x = -2, y = -16, z = 8},
				},
			},
		},
	},
	upperleg = {
		sprite = SPR2_PRTF,
		frames = {
			// 1: top
			// 2: bottom
			[0] = {
				joints = {
					[1] = {x = -14, y = 0, z = 4},
					[2] = {x = 10, y = 0, z = 4},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -12, y = 0, z = 10},
					[2] = {x = 9, y = 0, z = -1},
				},
			},
			[2] = {
				joints = {
					[1] = {x = -8, y = 0, z = 12},
					[2] = {x = 7, y = 0, z = -3},
				},
			},
			[3] = {
				joints = {
					[1] = {x = -6, y = 0, z = 14},
					[2] = {x = 4, y = 0, z = -5},
				},
			},
			[4] = {
				joints = {
					[1] = {x = 0, y = 0, z = 16},
					[2] = {x = 0, y = 0, z = -6},
				},
			},
			[5] = {
				joints = {
					[1] = {x = 6, y = 0, z = 14},
					[2] = {x = -4, y = 0, z = -5},
				},
			},
			[6] = {
				joints = {
					[1] = {x = 8, y = 0, z = 12},
					[2] = {x = -7, y = 0, z = -3},
				},
			},
			[7] = {
				joints = {
					[1] = {x = 12, y = 0, z = 10},
					[2] = {x = -9, y = 0, z = -1},
				},
			},
			[8] = {
				joints = {
					[1] = {x = 14, y = 0, z = 4},
					[2] = {x = -10, y = 0, z = 4},
				},
			},
		},
	},
	midleg = {
		sprite = SPR2_PRTM,
		frames = {
			// 1: top
			// 2: bottom
			[0] = {
				joints = {
					[1] = {x = -4, y = 0, z = 2},
					[2] = {x = 4, y = 0, z = 2},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -4, y = 0, z = 4},
					[2] = {x = 4, y = 0, z = 0},
				},
			},
			[2] = {
				joints = {
					[1] = {x = -3, y = 0, z = 5},
					[2] = {x = 3, y = 0, z = -1},
				},
			},
			[3] = {
				joints = {
					[1] = {x = -2, y = 0, z = 6},
					[2] = {x = 2, y = 0, z = -2},
				},
			},
			[4] = {
				joints = {
					[1] = {x = 0, y = 0, z = 6},
					[2] = {x = 0, y = 0, z = -2},
				},
			},
			[5] = {
				joints = {
					[1] = {x = 2, y = 0, z = 6},
					[2] = {x = -2, y = 0, z = -2},
				},
			},
			[6] = {
				joints = {
					[1] = {x = 3, y = 0, z = 5},
					[2] = {x = -3, y = 0, z = -1},
				},
			},
			[7] = {
				joints = {
					[1] = {x = 4, y = 0, z = 4},
					[2] = {x = -4, y = 0, z = 0},
				},
			},
			[8] = {
				joints = {
					[1] = {x = 4, y = 0, z = 2},
					[2] = {x = -4, y = 0, z = 2},
				},
			},
		},
	},
	lowerleg = {
		sprite = SPR2_PRTG,
		frames = {
			// 1: top
			// 2: bottom
			[0] = {
				joints = {
					[1] = {x = -12, y = 0, z = 6},
					[2] = {x = 12, y = 0, z = 6},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -10, y = 0, z = 12},
					[2] = {x = 10, y = 0, z = 2},
				},
			},
			[2] = {
				joints = {
					[1] = {x = -8, y = 0, z = 16},
					[2] = {x = 8, y = 0, z = -2},
				},
			},
			[3] = {
				joints = {
					[1] = {x = -4, y = 0, z = 18},
					[2] = {x = 4, y = 0, z = -4},
				},
			},
			[4] = {
				joints = {
					[1] = {x = 0, y = 0, z = 19},
					[2] = {x = 0, y = 0, z = -5},
				},
			},
			[5] = {
				joints = {
					[1] = {x = 4, y = 0, z = 18},
					[2] = {x = -4, y = 0, z = -4},
				},
			},
			[6] = {
				joints = {
					[1] = {x = 8, y = 0, z = 16},
					[2] = {x = -8, y = 0, z = -2},
				},
			},
			[7] = {
				joints = {
					[1] = {x = 10, y = 0, z = 12},
					[2] = {x = -10, y = 0, z = 2},
				},
			},
			[8] = {
				joints = {
					[1] = {x = 12, y = 0, z = 6},
					[2] = {x = -12, y = 0, z = 6},
				},
			},
		},
	},
	foot = {
		sprite = SPR2_PRTH,
		bright = SPR2_PBMH,
		frames = {
			// 1: joint
			[0] = {
				joints = {
					[1] = {x = -1, y = 0, z = 10},
				},
			},
			[1] = {
				joints = {
					[1] = {x = -1, y = 0, z = 11},
				},
			},
			[2] = {
				joints = {
					[1] = {x = -1, y = 0, z = 12},
				},
			},
			[3] = {
				joints = {
					[1] = {x = -1, y = 0, z = 11},
				},
			},
			[4] = {
				joints = {
					[1] = {x = -1, y = 0, z = 10},
				},
			},
		}
	},
	jet = {
		sprite = SPR2_PRTI,
		frames = {
			// 1: bottom
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
		}
	},
	propeller = {
		sprite = SPR2_PRTK,
		splat = true,
		frames = {
			// 1: bottom
			// 2: top
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 0, y = 0, z = 0},
				},
			},
			[1] = {
				joints = {
					[1] = {x = 0, y = 0, z = -2},
					[2] = {x = 0, y = 0, z = 2},
				},
			},
			[2] = {
				joints = {
					[1] = {x = 0, y = 0, z = -4},
					[2] = {x = 0, y = 0, z = 4},
				},
			},
			[3] = {
				joints = {
					[1] = {x = 0, y = 0, z = -7},
					[2] = {x = 0, y = 0, z = 7},
				},
			},
		},
	},
	laser = {
		sprite = SPR2_PRTN,
		bright = SPR2_PBMN,
		frames = {
			// 1: anchor
			// 2: laser
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 9, y = 0, z = 14},
				},
			},
			[1] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 15, y = 0, z = 10},
				},
			},
			[2] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 18, y = 0, z = 3},
				},
			},
			[3] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
					[2] = {x = 26, y = 10, z = 1},
				},
			},
		},
	},
	hat = {
		sprite = SPR2_PRTP,
		frames = {
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
		},
	},
	soda = {
		sprite = SPR2_PRTQ,
		frames = {
			[0] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[1] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[2] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[3] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[4] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[5] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[6] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[7] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[8] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[9] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[10] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[11] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
			[12] = {
				joints = {
					[1] = {x = 0, y = 0, z = 0},
				},
			},
		},
	},
}
