Gamma.CoopJumpGlowThink = function(mo)
	if not (mo.target and mo.target.valid and mo.target.health)
		return;
	end

	A_Custom3DRotate(mo, 48, 40<<16);

	local amp = 8;
	local speed = 4*TICRATE;
	local pi = 22*FRACUNIT/7;
	local sine = amp * sin((Gamma.tau * speed) * leveltime);

	mo.z = mo.target.z + (mo.target.height/2) + sine;
end

Gamma.CoopJumpGlowCreate = function(player)
	if (player.mo.gammaCoopJump.glow and player.mo.gammaCoopJump.glow.valid)
		return;
	end

	local newGlow = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_GAMMA_COOPJUMPGLOW);
	newGlow.color = Gamma.GetShotColor(player.mo.gammaCoopJump.origin);
	newGlow.target = player.mo;
	newGlow.angle = player.mo.angle;

	player.mo.gammaCoopJump.glow = newGlow;
end

Gamma.SpawnJumpCircle = function(parent, origin)
	local circle = P_SpawnMobjFromMobj(parent, 0, 0, 0, MT_GAMMA_SHOTTRAIL);
	circle.state = S_GAMMA_SHOTEXPLODE5;
	circle.renderflags = $1 | RF_FLOORSPRITE;
	circle.scale = $1 * 3;

	if (origin and origin.valid)
		circle.color = Gamma.GetShotColor(origin);
	elseif (parent.gammaCoopJump != nil)
		circle.color = Gamma.GetShotColor(parent.gammaCoopJump.origin);
	else
		circle.color = parent.color;
	end
end
