Gamma.DoSounds = function(player)
	if (player.followmobj and player.followmobj.valid and player.followmobj.gammaAnim != nil)
		local anim = player.followmobj.gammaAnim
		local onGround = P_IsObjectOnGround(player.mo)

		// Step sounds
		if (anim.spr2 == SPR2_WALK)
		and (onGround == true or player.powers[pw_carry] == CR_ROLLOUT)
			local playFor = nil

			if (anim.frame == 4)
				playFor = Gamma.AnimPartIDs.FOOT_L
			elseif (anim.frame == 8)
				playFor = Gamma.AnimPartIDs.FOOT_R
			end

			if (playFor != nil)
				Gamma.PlaySoundOnPart(player, playFor, sfx_gmstep)
				Gamma.StepDust(player, playFor);
			end
		end

		// Drive sounds
		if (player.mo.gammaVars.driving == true)
			local currentlyPlaying = (S_SoundPlaying(player.mo, sfx_gmdrvs) or S_SoundPlaying(player.mo, sfx_gmdrvl))

			if (currentlyPlaying == false)
				if (player.mo.gammaVars.driveSound == true)
					// Looped sound
					S_StartSoundAtVolume(player.mo, sfx_gmdrvl, 100)
				else
					// Start sound
					S_StartSoundAtVolume(player.mo, sfx_gmdrvs, 100)
				end
			end

			player.mo.gammaVars.driveSound = true
		else
			S_StopSoundByID(player.mo, sfx_gmdrvs)
			S_StopSoundByID(player.mo, sfx_gmdrvl)
			player.mo.gammaVars.driveSound = false
		end
	end
end

Gamma.TimeOutSparks = function(player)
	local timeVal = 30*TICRATE;

	if (player.gammaTime >= timeVal)
		return;
	end

	local chance = (timeVal - player.gammaTime) * ((FRACUNIT >> 1) / timeVal);
	if not (P_RandomChance(chance))
		return;
	end

	local radius = FixedDiv(player.mo.radius, player.mo.scale) / FRACUNIT;
	local halfHeight = FixedDiv(player.mo.height, player.mo.scale) >> 1;

	local xOffset = P_RandomRange(-radius, radius) * FRACUNIT;
	local yOffset = P_RandomRange(-radius, radius) * FRACUNIT;
	local zOffset = (P_RandomRange(-radius, radius) * FRACUNIT) + halfHeight;

	local zap = P_SpawnMobjFromMobj(player.mo, xOffset, yOffset, zOffset, MT_WATERZAP);
	S_StartSound(zap, sfx_beelec);

	zap.color = SKINCOLOR_VAPOR;
	zap.colorized = true;

	zap.renderflags = $1 | RF_FULLBRIGHT;
end

Gamma.ComboDropSound = function(player)
	S_StartSound(nil, sfx_kc65, player);
end
