Gamma.GetShotColor = function(player)
	if (Gamma.HaveBlasterUpgrade(player) == true)
		return SKINCOLOR_GAMMALASERSUPER;
	end

	return SKINCOLOR_GAMMALASER;
end

Gamma.SpawnTrail = function(parent, speed, hAngle, vAngle, x, y, z, origin)
	local origSize = mobjinfo[MT_GAMMA_SHOTTRAIL].radius;
	local origSpeed = mobjinfo[MT_GAMMA_SHOT].speed;

	local trailScale = FixedDiv(speed, origSpeed);
	if (trailScale <= 0)
		return nil;
	end

	local finalSize = FixedMul(origSize, trailScale);
	local extraX = FixedMul(FixedMul(finalSize, cos(hAngle)), cos(vAngle));
	local extraY = FixedMul(FixedMul(finalSize, sin(hAngle)), cos(vAngle));
	local extraZ = FixedMul(finalSize, sin(vAngle)) * P_MobjFlip(parent);

	local trailMobj = P_SpawnMobjFromMobj(parent, x + extraX, y + extraY, z + extraZ, MT_GAMMA_SHOTTRAIL);
	trailMobj.angle = hAngle;

	trailMobj.gammaTrailAng = vAngle; //trailMobj.rollangle = vAngle;
	Gamma.DoPaperRoll(trailMobj);

	trailMobj.target = parent;

	trailMobj.scale = trailScale;
	trailMobj.destscale = trailScale;

	if (origin != nil)
		trailMobj.color = Gamma.GetShotColor(origin);
	elseif (parent.gammaCoopJump != nil)
		trailMobj.color = Gamma.GetShotColor(parent.gammaCoopJump.origin);
	else
		trailMobj.color = parent.color;
	end

	return trailMobj;
end

Gamma.DoPaperRoll = function(mo)
	if (mo.gammaTrailAng == nil)
		return;
	end

	mo.rollangle = mo.gammaTrailAng;
	mo.rollangle = $1 * P_MobjFlip(mo);
end

Gamma.ShotTrailThink = function(mo)
	if (mo.target and mo.target.valid and mo.target.fuse > 0)
		mo.flags2 = $1 ^^ MF2_DONTDRAW;
	end

	Gamma.DoPaperRoll(mo);
end
