Gamma.CreateTargetWireframe = function(setTarget, player, combo, comboID)
	for i = 0,1 do
		local targetBox = P_SpawnMobj(setTarget.x, setTarget.y, setTarget.z, MT_GAMMA_TARGET);
		targetBox.tracer = setTarget;
		targetBox.target = player.mo;
		targetBox.gammaComboID = comboID;

		targetBox.angle = -ANGLE_90 * i;
		targetBox.color = Gamma.GetLaserColor(player, combo.expireTime);
		//targetBox.flags2 = $1 | MF2_LINKDRAW; // !! causes crashes !!

		P_SetScale(targetBox, targetBox.scale / 8);
		targetBox.scalespeed = $1 * 3;

		if (i == 1)
			targetBox.state = S_GAMMA_TARGET_RED;
		end
	end
end

Gamma.TargetThink = function(mo)
	local owner = mo.target;
	local follow = mo.tracer;

	if not (owner and owner.valid and owner.gammaVars != nil)
	or not (Gamma.ShotTargetAlive(follow))
		P_KillMobj(mo);
		return;
	end

	local combo = owner.gammaVars.comboList[mo.gammaComboID];
	if not (Gamma.ComboAlreadyTargeting(combo, follow))
		P_KillMobj(mo);
		return;
	end

	local newScale = FRACUNIT;

	if (follow.info.gammaTargetSize != nil)
		newScale = FixedDiv(FixedMul(follow.info.gammaTargetSize, follow.scale), mo.info.height);
	else
		newScale = max(
			FixedDiv(follow.radius, mo.info.radius),
			FixedDiv(follow.height, mo.info.height)
		);
	end

	mo.destscale = newScale;
	mo.angle = $1 + (ANG15 / 2);

	local z = follow.z + (follow.height / 2) - (mo.height / 2);
	if (mo.x != follow.x or mo.y != follow.y or mo.z != z)
		P_MoveOrigin(mo, follow.x, follow.y, z);
	end

	mo.momx = follow.momx;
	mo.momy = follow.momy;
	mo.momz = follow.momz;

	mo.color = Gamma.GetLaserColor(owner.player, combo.expireTime);

	if (combo.expireTime >= Gamma.ComboExpire - Gamma.ComboExpireBlink)
		mo.flags2 = $1 ^^ MF2_DONTDRAW;
	end
end
