//
// Arid Canyon decorations
//

mobjinfo[MT_OILLAMP].flags = $1 & ~MF_NOBLOCKMAP;

freeslot(
	"S_BIGTUMBLEWEED_SHARD",
	"S_LITTLETUMBLEWEED_SHARD",
	"SPR_TBWD",

	"S_ARIDSIGN_CAUTION_SHARD",
	"S_ARIDSIGN_CAUTION_DEAD",
	"SPR_WS1D",

	"S_ARIDSIGN_CACTI_SHARD",
	"S_ARIDSIGN_CACTI_DEAD",
	"SPR_WS2D",

	"S_ARIDSIGN_SHARPTURN_SHARD",
	"S_ARIDSIGN_SHARPTURN_DEAD",
	"SPR_WS3D",

	"S_OILLAMP_SHARD",
	"SPR_OILD"
);

states[S_BIGTUMBLEWEED_SHARD] = {SPR_TBWD, A, 35, nil, 0, 0, S_NULL};
states[S_LITTLETUMBLEWEED_SHARD] = {SPR_TBWD, E, 35, nil, 0, 0, S_NULL};

states[S_ARIDSIGN_CAUTION_SHARD] = {SPR_WS1D, A|FF_PAPERSPRITE, 35, nil, 0, 0, S_NULL};
states[S_ARIDSIGN_CAUTION_DEAD] = {SPR_WS1D, E|FF_PAPERSPRITE, -1, nil, 0, 0, S_NULL};

mobjinfo[MT_ARIDSIGN_CAUTION].deathstate = S_ARIDSIGN_CAUTION_DEAD;
mobjinfo[MT_ARIDSIGN_CAUTION].deathsound = sfx_wbreak;

states[S_ARIDSIGN_CACTI_SHARD] = {SPR_WS2D, A|FF_PAPERSPRITE, 35, nil, 0, 0, S_NULL};
states[S_ARIDSIGN_CACTI_DEAD] = {SPR_WS2D, E|FF_PAPERSPRITE, -1, nil, 0, 0, S_NULL};

mobjinfo[MT_ARIDSIGN_CACTI].deathstate = S_ARIDSIGN_CACTI_DEAD;
mobjinfo[MT_ARIDSIGN_CACTI].deathsound = sfx_wbreak;

states[S_ARIDSIGN_SHARPTURN_SHARD] = {SPR_WS3D, A|FF_PAPERSPRITE, 35, nil, 0, 0, S_NULL};
states[S_ARIDSIGN_SHARPTURN_DEAD] = {SPR_WS3D, B|FF_PAPERSPRITE, -1, nil, 0, 0, S_NULL};

mobjinfo[MT_ARIDSIGN_SHARPTURN].deathstate = S_ARIDSIGN_SHARPTURN_DEAD;
mobjinfo[MT_ARIDSIGN_SHARPTURN].deathsound = sfx_s3k96;
mobjinfo[MT_ARIDSIGN_SHARPTURN].gammaTargetSize = mobjinfo[MT_ARIDSIGN_SHARPTURN].radius / 2;

states[S_OILLAMP_SHARD] = {SPR_OILD, A, 35, nil, 0, 0, S_NULL};

Gamma.SetTargetFunc(MT_BIGTUMBLEWEED, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_LITTLETUMBLEWEED, Gamma.TargetFuncAlways);

Gamma.SetTargetFunc(MT_ARIDSIGN_CAUTION, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_ARIDSIGN_CACTI, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_ARIDSIGN_SHARPTURN, Gamma.TargetFuncAlways);

Gamma.SetTargetFunc(MT_OILLAMP, Gamma.TargetFuncAlways);

Gamma.SetTargetFunc(MT_FALLINGROCK, Gamma.TargetFuncAlways);

local function DamageTumbleweed(target, shot, source)
	local shardList = {
		{spr = 0, mom = 4, ang = ANGLE_22h},
		{spr = 1, mom = 4, ang = -ANGLE_22h},
		{spr = 2, mom = 6, ang = ANGLE_11hh},
		{spr = 3, mom = 6, ang = -ANGLE_11hh},
	};

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		if (target.type == MT_LITTLETUMBLEWEED)
			shard.state = S_LITTLETUMBLEWEED_SHARD;
		else
			shard.state = S_BIGTUMBLEWEED_SHARD;
		end
		shard.frame = $1 + shardInfo.spr;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);

		if (i == 1)
			S_StartSound(shard, target.info.activesound);
		end
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_BIGTUMBLEWEED, DamageTumbleweed);
Gamma.SetDamageFunc(MT_LITTLETUMBLEWEED, DamageTumbleweed);

local function DamageSignCaution(target, shot, source)
	local shardList = {
		{spr = 0, mom = 2, ang = ANGLE_11hh},
		{spr = 1, mom = 2, ang = -ANGLE_11hh},
		{spr = 2, mom = 4, ang = ANGLE_11hh},
		{spr = 3, mom = 4, ang = -ANGLE_11hh},
	};

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_ARIDSIGN_CAUTION_SHARD;
		shard.frame = $1 + shardInfo.spr;
		shard.angle = target.angle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);
	end

	A_Scream(target, 0, 0);
	P_KillMobj(target, shot, source);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_ARIDSIGN_CAUTION, DamageSignCaution);

local function DamageSignCacti(target, shot, source)
	local shardList = {
		{spr = 0, mom = 2, z = 0, ang = -ANGLE_11hh},
		{spr = 1, mom = 2, z = 0, ang = ANGLE_11hh},
		{spr = 2, mom = 4, z = 24*FRACUNIT, ang = -ANGLE_11hh},
		{spr = 3, mom = 4, z = 24*FRACUNIT, ang = ANGLE_11hh},
	};

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, 32*FRACUNIT + shardInfo.z, MT_BOSSJUNK);
		shard.state = S_ARIDSIGN_CACTI_SHARD;
		shard.frame = $1 + shardInfo.spr;
		shard.angle = target.angle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);
	end

	A_Scream(target, 0, 0);
	P_KillMobj(target, shot, source);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_ARIDSIGN_CACTI, DamageSignCacti);

local function DamageSignSharpTurn(target, shot, source)
	local tossAngle = P_RandomRange(0, 359) * ANG1;

	local shard = P_SpawnMobjFromMobj(target, 0, 0, 72*FRACUNIT, MT_BOSSJUNK);
	shard.state = S_ARIDSIGN_SHARPTURN_SHARD;
	shard.angle = target.angle;

	P_InstaThrust(shard, tossAngle, 4 * shard.scale);
	P_SetObjectMomZ(shard, 4 * FRACUNIT, false);

	A_Scream(target, 0, 0);
	P_KillMobj(target, shot, source);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_ARIDSIGN_SHARPTURN, DamageSignSharpTurn);

local function DamageOilLamp(target, shot, source)
	local shardList = {
		{spr = 0, mom = 2, ang = ANGLE_11hh},
		{spr = 1, mom = 2, ang = -ANGLE_11hh},
		{spr = 2, mom = 4, ang = ANGLE_11hh},
		{spr = 3, mom = 4, ang = -ANGLE_11hh},
	};

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	local flameSpawner = P_SpawnMobjFromMobj(target, 0, 0, h, MT_CASTLEVANIA_FLAMESPAWNER);
	flameSpawner.tics = 17;
	S_StartSound(flameSpawner, sfx_s3k96); --sfx_cvcndl

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_OILLAMP_SHARD;
		shard.frame = $1 + shardInfo.spr;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_OILLAMP, DamageOilLamp);

local function DamageMeatball(target, shot, source)
	local shardList = {
		{spr = 0, mom = 6, ang = ANGLE_22h},
		{spr = 1, mom = 6, ang = -ANGLE_22h},
		{spr = 2, mom = 12, ang = ANGLE_22h},
		{spr = 3, mom = 12, ang = -ANGLE_22h},
	};

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = target.state;
		shard.angle = tossAngle;

		shard.scale = $1 / 3;

		P_InstaThrust(shard, tossAngle, 8 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);

		if (i == 1)
			S_StartSound(shard, sfx_s3k96);
		end
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_FALLINGROCK, DamageMeatball);
