//
// Azure Temple dumb ass shit
//

mobjinfo[MT_BLUECRYSTAL].flags = $1 & ~MF_NOBLOCKMAP;

freeslot(
	"S_GLAREGOYLE_SHARD",
	"SPR_BGRD",

	"S_BLUECRYSTAL_SHARD",
	"SPR_BCRD"
);

states[S_GLAREGOYLE_SHARD] = {SPR_BGRD, A, 35, nil, 0, 0, S_NULL};

states[S_BLUECRYSTAL_SHARD] = {SPR_BCRD, A|FF_TRANS30, 35, nil, 0, 0, S_NULL}

Gamma.SetTargetFunc(MT_GLAREGOYLE, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_GLAREGOYLEUP, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_GLAREGOYLEDOWN, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_GLAREGOYLELONG, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_BLUEGARGOYLE, Gamma.TargetFuncAlways);

Gamma.SetTargetFunc(MT_BLUECRYSTAL, Gamma.TargetFuncAlways);

local function DamageGlaregoyle(target, shot, source)
	if (target.flags & MF_PUSHABLE)
		-- Can't blow it up, it's for progression.
		Gamma.ShotPush(target, shot);
		return Gamma.SHOT_EXPLODE;
	end

	local blueOffset = 0;
	if (target.type == MT_BLUEGARGOYLE)
		blueOffset = 1;
	end

	local shard = nil;
	local tossAngle = nil;
	local sign = nil;

	-- Head
	shard = P_SpawnMobjFromMobj(target, 12*FRACUNIT, 0, 24*FRACUNIT, MT_BOSSJUNK);
	shard.state = S_GLAREGOYLE_SHARD;
	shard.angle = target.angle;
	shard.frame = $1 + blueOffset;

	P_SetObjectMomZ(shard, 6*FRACUNIT, false);
	S_StartSound(shard, sfx_s3k96);

	-- Body
	tossAngle = target.angle + ANGLE_180;

	shard = P_SpawnMobjFromMobj(target, 8*FRACUNIT, 0, 8*FRACUNIT, MT_BOSSJUNK);
	shard.state = S_GLAREGOYLE_SHARD;
	shard.frame = $1 + 2 + blueOffset;
	shard.angle = tossAngle;

	P_InstaThrust(shard, tossAngle, shard.scale);
	P_SetObjectMomZ(shard, 4*FRACUNIT, false);

	-- Wings
	tossAngle = target.angle + ANGLE_135;
	sign = 1;
	for i = 0,1
		shard = P_SpawnMobjFromMobj(target, -8*FRACUNIT, 12*FRACUNIT * sign, 8*FRACUNIT, MT_BOSSJUNK);
		shard.state = S_GLAREGOYLE_SHARD;
		shard.frame = $1 + 4 + i;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4*shard.scale);
		P_SetObjectMomZ(shard, 4*FRACUNIT, false);

		tossAngle = $1 + ANGLE_90;
		sign = -$1;
	end

	-- Legs
	tossAngle = target.angle + ANGLE_45;
	sign = 1;
	for i = 0,1
		shard = P_SpawnMobjFromMobj(target, 10*FRACUNIT, 6*FRACUNIT * sign, 0, MT_BOSSJUNK);
		shard.state = S_GLAREGOYLE_SHARD;
		shard.frame = $1 + 6 + i;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4*shard.scale);
		P_SetObjectMomZ(shard, 4*FRACUNIT, false);

		tossAngle = $1 - ANGLE_90;
		sign = -$1;
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_GLAREGOYLE, DamageGlaregoyle);
Gamma.SetDamageFunc(MT_GLAREGOYLEUP, DamageGlaregoyle);
Gamma.SetDamageFunc(MT_GLAREGOYLEDOWN, DamageGlaregoyle);
Gamma.SetDamageFunc(MT_GLAREGOYLELONG, DamageGlaregoyle);
Gamma.SetDamageFunc(MT_BLUEGARGOYLE, DamageGlaregoyle);

local function DamageBlueCrystal(target, shot, source)
	local numShards = 3;
	local numSprites = 3;

	for i = 1,numShards
		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_BLUECRYSTAL_SHARD;
		shard.frame = $1 + P_RandomKey(numSprites);
		shard.angle = P_RandomRange(0, 359) * ANG1;

		P_InstaThrust(shard, shard.angle, P_RandomRange(4, 6) * shard.scale);
		P_SetObjectMomZ(shard, P_RandomRange(6, 10) * FRACUNIT, false);

		if (shard.eflags & MFE_VERTICALFLIP)
			-- Just flip the sprite, not the gravity.
			shard.eflags = $1 & ~MFE_VERTICALFLIP;
			shard.flags2 = $1 & ~MF2_OBJECTFLIP;
			shard.renderflags = $1 | RF_VERTICALFLIP;
		end

		if (i == 1)
			S_StartSound(shard, sfx_cnglas);
		end
	end

	P_KillMobj(target, shot, source);

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_BLUECRYSTAL, DamageBlueCrystal);
