//
// Castle Eggman decorations
//

mobjinfo[MT_FIRETORCH].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_PARTICLE].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_CANDLE].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_CEZPOLE1].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_CEZPOLE2].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_CEZBANNER1].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_CEZBANNER2].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_CHAIN].flags = $1 & ~MF_NOBLOCKMAP;

freeslot(
	-- Shamelessly lifted from kart v2
	-- (Actually shamelessly, because I MADE IT :P)
	"MT_CASTLEVANIA_FLAMESPAWNER",
	"MT_CASTLEVANIA_FLAME",
	"S_CASTLEVANIA_FLAME1",
	"S_CASTLEVANIA_FLAME2",
	"S_CASTLEVANIA_FLAME3",
	"S_CASTLEVANIA_FLAME4",
	"SPR_CVFL",
	"sfx_cvcndl",

	"S_CASTLETORCH_SHARD",
	"SPR_CTDB",

	"S_FLAMEHOLDER_DEAD",
	"S_CANDLEPRICKET_DEAD",

	"S_CEZBANNER_SHARD",
	"S_CEZPOLE_DEAD",
	"SPR_CEBD",

	"S_WAVINGFLAG_SHARD",
	"S_WAVINGFLAG_DEAD",
	"SPR_CEFD",

	"S_EGGSTATUE_SHARD",
	"SPR_ESDB",

	"S_FACESTABBERSTATUE_SHARD",
	"SPR_FSSD",

	"S_CRAWLASTATUE_SHARD",
	"SPR_CSDB",

	"S_CEZCHAIN_SHARD",
	"SPR_CHND"
);

--[[
-- UNUSED, because I actually think this effect looks hideous :V
-- I made my own and replaced the vanilla one.
local function StatueBurstNoEnemy(target, chunktype, scale)
	for i = 0,7 do
		local a = 0;
		local b = 0;
		local c = (target.height>>2) - FixedMul(target.scale, mobjinfo[chunktype].height>>1);
		local v = 4<<FRACBITS;
		local r = (target.radius>>1);

		if (i & 1)
			a = r;
		else
			a = -r;
		end

		if (i & 2)
			a = r;
		else
			a = -r;
		end

		if (i == 4)
			c = $1 + (target.height>>1);
			v = 8<<FRACBITS;
		end

		local spawned = P_SpawnMobjFromMobj(target, a, b, c, chunktype);

		P_InstaThrust(spawned, R_PointToAngle2(0, 0, a, b), 8<<FRACBITS);
		P_SetObjectMomZ(spawned, v, false);

		spawned.fuse = 3*TICRATE;

		if (scale != nil)
			spawned.destscale = FixedMul($1, scale);
			P_SetScale(spawned, spawned.destscale);
		end

		if (i == 4)
			S_StartSound(target, sfx_s3k96);
		end
	end

	P_RemoveMobj(target);
end
--]]

local function SpawnCastlevaniaFlame(mo, objectType, speed)
	local r = mo.radius / FRACUNIT;
	local h = mo.height / FRACUNIT;

	local x = P_RandomRange(-r, r) * FRACUNIT;
	local y = P_RandomRange(-r, r) * FRACUNIT;
	local z = P_RandomRange(0, h) * FRACUNIT;

	local flame = P_SpawnMobjFromMobj(mo, x, y, z, objectType);

	local speedScale = mo.scale >> 2;
	flame.momx = P_RandomRange(-speed, speed) * speedScale;
	flame.momy = P_RandomRange(-speed, speed) * speedScale;
	flame.momz = P_RandomRange(speed/2, speed*3) * speedScale * P_MobjFlip(mo);

	P_SetScale(flame, flame.scale * 3);
	return flame;
end

function A_SpawnCastlevaniaFlame(mo, v1, v2)
	local objectType = v1;
	local speed = v2;

	local flame = SpawnCastlevaniaFlame(mo, objectType, speed);
end

mobjinfo[MT_CASTLEVANIA_FLAMESPAWNER] = {
	doomednum = 2479,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY
}

mobjinfo[MT_CASTLEVANIA_FLAME] = {
	spawnstate = S_CASTLEVANIA_FLAME1,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY|MF_RUNSPAWNFUNC
}

states[S_CASTLEVANIA_FLAME1] = {SPR_CVFL, FF_FULLBRIGHT|A, 5, A_SetRandomTics, 3, 7, S_CASTLEVANIA_FLAME2};
states[S_CASTLEVANIA_FLAME2] = {SPR_CVFL, FF_FULLBRIGHT|B, 3, nil, 0, 0, S_CASTLEVANIA_FLAME3};
states[S_CASTLEVANIA_FLAME3] = {SPR_CVFL, FF_FULLBRIGHT|C, 2, nil, 0, 0, S_CASTLEVANIA_FLAME4};
states[S_CASTLEVANIA_FLAME4] = {SPR_CVFL, FF_FULLBRIGHT|D, 2, nil, 0, 0, S_NULL};

states[S_CASTLETORCH_SHARD] = {SPR_CTDB, A, 35, nil, 0, 0, S_NULL};

states[S_FLAMEHOLDER_DEAD] = {SPR_CTDB, E, -1, nil, 0, 0, S_NULL};
mobjinfo[MT_FLAMEHOLDER].deathstate = S_FLAMEHOLDER_DEAD;
mobjinfo[MT_FLAMEHOLDER].deathsound = sfx_wbreak;

states[S_CANDLEPRICKET_DEAD] = {SPR_CTDB, G, -1, nil, 0, 0, S_NULL};
mobjinfo[MT_CANDLEPRICKET].deathstate = S_CANDLEPRICKET_DEAD;
mobjinfo[MT_CANDLEPRICKET].deathsound = sfx_wbreak;
mobjinfo[MT_CANDLEPRICKET].gammaTargetSize = mobjinfo[MT_CANDLE].height;

states[S_CEZBANNER_SHARD] = {SPR_CEBD, B|FF_PAPERSPRITE, 35, nil, 0, 0, S_NULL};

states[S_CEZPOLE_DEAD] = {SPR_CEBD, A, -1, nil, 0, 0, S_NULL};
mobjinfo[MT_CEZPOLE1].deathstate = S_CEZPOLE_DEAD;
mobjinfo[MT_CEZPOLE1].deathsound = sfx_wbreak;
mobjinfo[MT_CEZPOLE1].gammaTargetSize = mobjinfo[MT_CEZPOLE1].radius * 2;

mobjinfo[MT_CEZPOLE2].deathstate = S_CEZPOLE_DEAD;
mobjinfo[MT_CEZPOLE2].deathsound = sfx_wbreak;
mobjinfo[MT_CEZPOLE2].gammaTargetSize = mobjinfo[MT_CEZPOLE2].radius * 2;

states[S_WAVINGFLAG_SHARD] = {SPR_CEFD, B|FF_PAPERSPRITE, 35, nil, 0, 0, S_NULL};

states[S_WAVINGFLAG_DEAD] = {SPR_CEFD, A, -1, nil, 0, 0, S_NULL};
mobjinfo[MT_WAVINGFLAG1].deathstate = S_WAVINGFLAG_DEAD;
mobjinfo[MT_WAVINGFLAG1].deathsound = sfx_wbreak;
mobjinfo[MT_WAVINGFLAG1].gammaTargetSize = mobjinfo[MT_WAVINGFLAG1].radius * 2;

mobjinfo[MT_WAVINGFLAG2].deathstate = S_WAVINGFLAG_DEAD;
mobjinfo[MT_WAVINGFLAG2].deathsound = sfx_wbreak;
mobjinfo[MT_WAVINGFLAG2].gammaTargetSize = mobjinfo[MT_WAVINGFLAG2].radius * 2;

states[S_EGGSTATUE_SHARD] = {SPR_ESDB, A, 35, nil, 0, 0, S_NULL};
states[S_FACESTABBERSTATUE_SHARD] = {SPR_FSSD, A, 35, nil, 0, 0, S_NULL};
states[S_CRAWLASTATUE_SHARD] = {SPR_CSDB, A, 35, nil, 0, 0, S_NULL};

mobjinfo[MT_CHAIN].gammaTargetSize = mobjinfo[MT_CHAIN].radius * 4;
states[S_CEZCHAIN_SHARD] = {SPR_CHND, A, 35, nil, 0, 0, S_NULL};

addHook("MobjThinker", function(mo)
	local time = leveltime;

	if (mo.tics > 0)
		time = mo.tics;
	end

	if (time & 1)
		SpawnCastlevaniaFlame(mo, MT_CASTLEVANIA_FLAME, 12);
	end
end, MT_CASTLEVANIA_FLAMESPAWNER);

addHook("MobjThinker", function(mo)
	mo.renderflags = $1 ^^ RF_HORIZONTALFLIP;
end, MT_CASTLEVANIA_FLAME);

Gamma.SetTargetFunc(MT_FIRETORCH, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_FLAMEHOLDER, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_CANDLE, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_CANDLEPRICKET, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_CEZPOLE1, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_CEZPOLE2, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_WAVINGFLAG1, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_WAVINGFLAG2, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_EGGSTATUE, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_FACESTABBERSTATUE, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_SUSPICIOUSFACESTABBERSTATUE, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_CRAWLASTATUE, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_CHAIN, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_CANNONBALLDECOR, Gamma.TargetFuncAlways);

local function DamageTorch(target, shot, source)
	local flameSpawner = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_CASTLEVANIA_FLAMESPAWNER);
	flameSpawner.tics = 17;
	S_StartSound(flameSpawner, sfx_cvcndl);

	local tossAngle = P_RandomRange(0, 359) * ANG1;
	for i = 0,1
		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_CASTLETORCH_SHARD;
		shard.frame = $1 + i;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, 4 * FRACUNIT, false);

		tossAngle = $1 + ANGLE_180;
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_FIRETORCH, DamageTorch);

local function DamageFlameHolder(target, shot, source)
	local fire = Gamma.FindAttachedObjects(target, {MT_FLAME, MT_PARTICLE}, 0, mobjinfo[MT_FLAME].height);
	local fireValid = false;
	for _,v in pairs(fire) do
		if (v and v.valid)
			P_RemoveMobj(v);
			fireValid = true;
		end
	end

	if (fireValid == true)
		local h = FixedDiv((target.height * 3) / 4, target.scale);
		local flameSpawner = P_SpawnMobjFromMobj(target, 0, 0, h, MT_CASTLEVANIA_FLAMESPAWNER);
		flameSpawner.tics = 17;
		S_StartSound(flameSpawner, sfx_cvcndl);
	end

	for i = 0,1
		local tossAngle = P_RandomRange(0, 359) * ANG1;
		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_CASTLETORCH_SHARD;
		shard.frame = $1 + 2 + i;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, 4 * FRACUNIT, false);
	end

	A_Scream(target, 0, 0);
	P_KillMobj(target, shot, source);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_FLAMEHOLDER, DamageFlameHolder);

local function DamageCandle(target, shot, source)
	local corona = Gamma.FindAttachedObjects(target, MT_PARTICLE);
	for _,v in pairs(corona) do
		if (v and v.valid)
			P_RemoveMobj(v);
		end
	end

	local flameSpawner = P_SpawnMobjFromMobj(target, 0, 0, h, MT_CASTLEVANIA_FLAMESPAWNER);
	flameSpawner.tics = 7;
	S_StartSound(flameSpawner, sfx_cvcndl);

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_CANDLE, DamageCandle);

local function DamageCandlePricket(target, shot, source)
	local corona = Gamma.FindAttachedObjects(target, MT_PARTICLE);
	for _,v in pairs(corona) do
		if (v and v.valid)
			P_RemoveMobj(v);
		end
	end

	local flameSpawner = P_SpawnMobjFromMobj(target, 0, 0, 128*FRACUNIT, MT_CASTLEVANIA_FLAMESPAWNER);
	flameSpawner.tics = 7;
	S_StartSound(flameSpawner, sfx_cvcndl);

	local z = 104*FRACUNIT;
	for i = 0,3 do
		local tossAngle = P_RandomRange(0, 359) * ANG1;
		local shard = P_SpawnMobjFromMobj(target, 0, 0, z, MT_BOSSJUNK);
		shard.state = S_CASTLETORCH_SHARD;
		shard.frame = $1 + 5;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, 4 * FRACUNIT, false);

		z = $1 - (25*FRACUNIT);
	end

	A_Scream(target, 0, 0);
	P_KillMobj(target, shot, source);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_CANDLEPRICKET, DamageCandlePricket);

local function DamageCEZBanner(target, shot, source)
	local bannerType = MT_CEZBANNER1;
	local bannerOffset = 0;

	if (target.type == MT_CEZPOLE2)
		bannerType = MT_CEZBANNER2;
		bannerOffset = 4;
	end

	local banner = Gamma.FindAttachedObjects(target, bannerType);
	for _,v in pairs(banner) do
		if (v and v.valid)
			P_RemoveMobj(v);
		end
	end

	-- Pole
	local z = 192*FRACUNIT;
	local tossAngle = 0;

	for i = 0,3 do
		z = $1 - (48*FRACUNIT);

		tossAngle = P_RandomRange(0, 359) * ANG1;
		local shard = P_SpawnMobjFromMobj(target, 0, 0, z, MT_BOSSJUNK);
		shard.state = S_CEZBANNER_SHARD;
		shard.frame = $1 & ~FF_PAPERSPRITE;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, 4 * FRACUNIT, false);
	end

	-- Banner
	local bx = P_ReturnThrustX(target, target.angle, 4 << FRACBITS);
	local by = P_ReturnThrustY(target, target.angle, 4 << FRACBITS);
	z = 172*FRACUNIT;

	for i = 0,1 do
		tossAngle = target.angle + ANGLE_90;

		local shard = P_SpawnMobjFromMobj(target, bx, by, z, MT_BOSSJUNK);
		shard.state = S_CEZBANNER_SHARD;
		shard.frame = $1 + 1;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, 4 * FRACUNIT, false);

		tossAngle = $1 + ANGLE_180;
	end

	z = $1 - (35*FRACUNIT);

	for i = 0,3 do
		tossAngle = target.angle + ANGLE_90;

		for j = 0,1 do
			local shard = P_SpawnMobjFromMobj(target, bx, by, z, MT_BOSSJUNK);
			shard.state = S_CEZBANNER_SHARD;
			shard.frame = $1 + 2 + i + bannerOffset;
			shard.angle = tossAngle;

			P_InstaThrust(shard, tossAngle, (2 + i) * shard.scale);
			P_SetObjectMomZ(shard, 4 * FRACUNIT, false);
			--shard.flags = $1 | MF_NOGRAVITY;

			tossAngle = $1 + ANGLE_180;
		end

		z = $1 - (40*FRACUNIT);
	end

	A_Scream(target, 0, 0);
	P_KillMobj(target, shot, source);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_CEZPOLE1, DamageCEZBanner);
Gamma.SetDamageFunc(MT_CEZPOLE2, DamageCEZBanner);

local function DamageCEZFlag(target, shot, source)
	local flagOffset = 0;
	if (target.type == MT_WAVINGFLAG2)
		flagOffset = 1;
	end

	-- Pole
	local shard = P_SpawnMobjFromMobj(target, 0, 0, 32*FRACUNIT, MT_BOSSJUNK);
	shard.state = S_WAVINGFLAG_SHARD;
	shard.frame = $1 & ~FF_PAPERSPRITE;
	shard.angle = target.angle + ANGLE_180;

	P_InstaThrust(shard, shard.angle, 4 * shard.scale);
	P_SetObjectMomZ(shard, 4 * FRACUNIT, false);

	-- Flag segments
	local seg = target.tracer;
	local segnum = 0;
	while (seg and seg.valid)
		local nextSeg = seg.tracer;

		shard = P_SpawnMobjFromMobj(seg, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_WAVINGFLAG_SHARD;
		shard.frame = $1 + 1 + flagOffset;
		shard.angle = seg.angle;

		P_InstaThrust(shard, seg.angle, (6 + i) * (shard.scale / 4));
		P_SetObjectMomZ(shard, 4 * FRACUNIT, false);

		P_RemoveMobj(seg);

		segnum = $1 + 1;
		seg = nextSeg;
	end

	A_Scream(target, 0, 0);
	P_KillMobj(target, shot, source);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_WAVINGFLAG1, DamageCEZFlag);
Gamma.SetDamageFunc(MT_WAVINGFLAG2, DamageCEZFlag);

local function DamageEggStatue(target, shot, source)
	if (target.flags & MF_PUSHABLE)
		-- Can't blow it up, it's for progression.
		Gamma.ShotPush(target, shot);
		return Gamma.SHOT_EXPLODE;
	end

	local shardList = {
		{spr = 0, mom = 8, ang = 0},
		{spr = 1, mom = 7, ang = 0},
		{spr = 2, mom = 6, ang = ANGLE_22h},
		{spr = 3, mom = 6, ang = 0},
		{spr = 4, mom = 6, ang = -ANGLE_22h},
		{spr = 5, mom = 5, ang = ANGLE_11hh},
		{spr = 6, mom = 5, ang = -ANGLE_11hh},
		{spr = 7, mom = 4, ang = ANG1},
		{spr = 8, mom = 4, ang = -ANG1},
	};

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_EGGSTATUE_SHARD;
		shard.frame = $1 + shardInfo.spr;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 6 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);

		shard.color = target.color;
		shard.colorized = target.colorized;

		if (i == 1)
			S_StartSound(shard, sfx_s3k96);
		end
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_EGGSTATUE, DamageEggStatue);

local function FacestabberStatueDebris(target, origTossAngle)
	local shardList = {
		{spr = 0, mom = 4, ang = ANGLE_11hh},
		{spr = 1, mom = 4, ang = -ANGLE_11hh},
		{spr = 2, mom = 6, ang = ANGLE_22h},
		{spr = 3, mom = 6, ang = -ANGLE_22h},
	};

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_FACESTABBERSTATUE_SHARD;
		shard.frame = $1 + shardInfo.spr;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);

		if (i == 1)
			S_StartSound(shard, sfx_s3k96);
		end
	end
end

local function FacestabberStatueBurst(actor, newTarget, origTossAngle, obj, st)
	local new = P_SpawnMobjFromMobj(actor, 0, 0, 0, obj);

	if not (new and new.valid)
		return;
	end

	new.angle = actor.angle;
	new.target = newTarget;
	if (st)
		new.state = st;
	end
	S_StartSound(new, new.info.attacksound);

	FacestabberStatueDebris(actor, origTossAngle);
	P_RemoveMobj(actor);
end

-- Replace the vanilla effect, too!
function A_FacestabberStatueBurst(actor, var1, var2)
	FacestabberStatueBurst(actor, actor.target, actor.angle + ANGLE_180, var1, var2);
end

states[S_SUSPICIOUSFACESTABBERSTATUE_BURST2].action = A_FacestabberStatueBurst;

local function DamageFacestabberStatue(target, shot, source)
	if (target.flags & MF_PUSHABLE)
		-- Can't blow it up, it's for progression.
		Gamma.ShotPush(target, shot);
		return Gamma.SHOT_EXPLODE;
	end

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);
	FacestabberStatueDebris(target, origTossAngle);
	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_FACESTABBERSTATUE, DamageFacestabberStatue);

local function DamageSusFacestabberStatue(target, shot, source)
	--[[
	-- While this can have the pushable flag (according to the source)...
	-- It also gets destroyed on its own so :V
	if (target.flags & MF_PUSHABLE)
		-- Can't blow it up, it's for progression.
		Gamma.ShotPush(target, shot);
		return Gamma.SHOT_EXPLODE;
	end
	--]]

	local origTossAngle = target.angle + ANGLE_180; -- R_PointToAngle2(shot.x, shot.y, target.x, target.y);
	FacestabberStatueBurst(target, source, origTossAngle,
		states[S_SUSPICIOUSFACESTABBERSTATUE_BURST2].var1,
		states[S_SUSPICIOUSFACESTABBERSTATUE_BURST2].var2
	);

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_SUSPICIOUSFACESTABBERSTATUE, DamageSusFacestabberStatue);

local function DamageCrawlaStatue(target, shot, source)
	if (target.flags & MF_PUSHABLE)
		-- Can't blow it up, it's for progression.
		Gamma.ShotPush(target, shot);
		return Gamma.SHOT_EXPLODE;
	end

	local shardList = {
		{spr = 0, mom = 4, ang = ANGLE_11hh},
		{spr = 1, mom = 4, ang = -ANGLE_11hh},
		{spr = 2, mom = 6, ang = 0},
	};

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_CRAWLASTATUE_SHARD;
		shard.frame = $1 + shardInfo.spr;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);

		if (i == 1)
			S_StartSound(shard, sfx_s3k96);
		end
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_CRAWLASTATUE, DamageCrawlaStatue);

local function DamageCEZChain(target, shot, source)
	for i = 1,4
		local tossAngle = P_RandomRange(0, 359) * ANG1;
		local tossZ = (i - 1) * 32 * FRACUNIT;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, tossZ, MT_BOSSJUNK);
		shard.state = S_CEZCHAIN_SHARD;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, i * FRACUNIT, false);

		if (i == 1)
			S_StartSound(shard, sfx_s3k96);
		end
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_CHAIN, DamageCEZChain);

local function DamageCEZCannonball(target, shot, source)
	if (target.flags & MF_PUSHABLE)
		-- Can't blow it up, it's for progression.
		Gamma.ShotPush(target, shot);
		return Gamma.SHOT_EXPLODE;
	end

	P_KillMobj(target, shot, source);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_CANNONBALLDECOR, DamageCEZCannonball);
