//
// KILL ALL DISCO
//

mobjinfo[MT_DBALL].flags = $1 & ~MF_NOBLOCKMAP;

freeslot(
	"S_DBALL_SHARD_A",
	"S_DBALL_SHARD_A2",
	"S_DBALL_SHARD_A3",
	"S_DBALL_SHARD_A4",
	"S_DBALL_SHARD_A5",
	"S_DBALL_SHARD_A6",
	"S_DBALL_SHARD_A7",
	"S_DBALL_SHARD_A8",
	"S_DBALL_SHARD_B",
	"S_DBALL_SHARD_B2",
	"S_DBALL_SHARD_B3",
	"S_DBALL_SHARD_B4",
	"S_DBALL_SHARD_B5",
	"S_DBALL_SHARD_B6",
	"S_DBALL_SHARD_B7",
	"S_DBALL_SHARD_B8",
	"SPR_DBLD",

	"S_EGGSTATUE2_SHARD",
	"SPR_ES2D"
);

states[S_DBALL_SHARD_A] = {SPR_DBLD, A|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_A2};
states[S_DBALL_SHARD_A2] = {SPR_DBLD, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_A3};
states[S_DBALL_SHARD_A3] = {SPR_DBLD, C|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_A4};
states[S_DBALL_SHARD_A4] = {SPR_DBLD, D|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_A5};
states[S_DBALL_SHARD_A5] = {SPR_DBLD, E|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_A6};
states[S_DBALL_SHARD_A6] = {SPR_DBLD, D|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_A7};
states[S_DBALL_SHARD_A7] = {SPR_DBLD, C|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_A8};
states[S_DBALL_SHARD_A8] = {SPR_DBLD, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_A};

states[S_DBALL_SHARD_B] = {SPR_DBLD, F|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_B2};
states[S_DBALL_SHARD_B2] = {SPR_DBLD, G|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_B3};
states[S_DBALL_SHARD_B3] = {SPR_DBLD, H|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_B4};
states[S_DBALL_SHARD_B4] = {SPR_DBLD, I|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_B5};
states[S_DBALL_SHARD_B5] = {SPR_DBLD, J|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_B6};
states[S_DBALL_SHARD_B6] = {SPR_DBLD, I|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_B7};
states[S_DBALL_SHARD_B7] = {SPR_DBLD, H|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_B8};
states[S_DBALL_SHARD_B8] = {SPR_DBLD, G|FF_FULLBRIGHT, 2, nil, 0, 0, S_DBALL_SHARD_B};

states[S_EGGSTATUE2_SHARD] = {SPR_ES2D, A, 35, nil, 0, 0, S_NULL};

Gamma.SetTargetFunc(MT_DBALL, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_EGGSTATUE2, Gamma.TargetFuncAlways);

local function DamageDiscoBall(target, shot, source)
	local numShards = 8;
	for i = 1,numShards
		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		if (P_RandomKey(2))
			shard.state = S_DBALL_SHARD_B;
		else
			shard.state = S_DBALL_SHARD_A;
		end
		shard.angle = P_RandomRange(0, 359) * ANG1;
		shard.fuse = TICRATE;

		P_InstaThrust(shard, shard.angle, 4 * shard.scale);
		P_SetObjectMomZ(shard, P_RandomRange(-2, 2) * FRACUNIT, false);

		if (i == 1)
			S_StartSound(shard, sfx_cnglas);
		end
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_DBALL, DamageDiscoBall);

local function DamageDiscoEggStatue(target, shot, source)
	if (target.flags & MF_PUSHABLE)
		-- Can't blow it up, it's for progression.
		Gamma.ShotPush(target, shot);
		return Gamma.SHOT_EXPLODE;
	end

	local shardList = {
		{spr = 0, mom = 8, ang = 0},
		{spr = 1, mom = 6, ang = ANGLE_22h},
		{spr = 2, mom = 6, ang = -ANGLE_22h},
		{spr = 3, mom = 4, ang = 0},
	};

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_EGGSTATUE2_SHARD;
		shard.frame = $1 + shardInfo.spr;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 6 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);

		shard.color = target.color;
		shard.colorized = target.colorized;

		if (i == 1)
			S_StartSound(shard, sfx_s3k96);
		end
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_EGGSTATUE2, DamageDiscoEggStatue);
