//
// Rosy
//

local function GammaHook_DamageRosy(target, shot, source)
	// Enable Coop jump ability ... :P
	target.state = S_ROSY_JUMP;
	target.z = $1 + P_MobjFlip(target);
	P_SetObjectMomZ(target, 12*FRACUNIT, false);
	S_StartSound(target, sfx_cdfm02);

	Gamma.SpawnJumpCircle(target, source.player);
	target.hnext = source;
	target.extravalue1 = 1;

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_ROSY, GammaHook_DamageRosy);

addHook("MobjThinker", function(mo)
	if (mo.extravalue1)
		if (P_IsObjectOnGround(mo) == true)
			mo.extravalue1 = 0;
		else
			local xydist = P_AproxDistance(mo.momx, mo.momy);
			local zdist = mo.momz;
			local speed = FixedHypot(xydist, zdist);

			local hAngle = R_PointToAngle2(0, 0, mo.momx, mo.momy);
			local vAngle = R_PointToAngle2(0, 0, xydist, zdist);

			/*
			local baseRad = FixedDiv(mo.radius, mo.scale)
			local xOffset = FixedMul(baseRad, cos(hAngle + ANGLE_90))
			local yOffset = FixedMul(baseRad, sin(hAngle + ANGLE_90))
			*/
			local zOffset = FixedDiv(mo.height, mo.scale) >> 1;

			local origin = nil;
			if (mo.hnext and mo.hnext.valid)
				origin = mo.hnext.player;
			end

			Gamma.SpawnTrail(
				mo, speed, hAngle, vAngle,
				0, 0, zOffset, origin
			);
		end
	end
end, MT_ROSY);

//
// Frozen Hillside ice
//

mobjinfo[MT_FHZICE1].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_FHZICE2].flags = $1 & ~MF_NOBLOCKMAP;

freeslot(
	"S_FHZICE_DEAD1",
	"S_FHZICE_DEAD2",
	"S_FHZICE_SHARD",
	"SPR_FHID"
);

states[S_FHZICE_DEAD1] = {SPR_FHID, A, -1, nil, 0, 0, S_NULL}
states[S_FHZICE_DEAD2] = {SPR_FHID, B, -1, nil, 0, 0, S_NULL}

mobjinfo[MT_FHZICE1].deathstate = S_FHZICE_DEAD1;
mobjinfo[MT_FHZICE1].deathsound = sfx_cnglas;

mobjinfo[MT_FHZICE2].deathstate = S_FHZICE_DEAD2;
mobjinfo[MT_FHZICE2].deathsound = sfx_cnglas;

states[S_FHZICE_SHARD] = {SPR_FHID, C, 35, nil, 0, 0, S_NULL}

Gamma.SetTargetFunc(MT_FHZICE1, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_FHZICE2, Gamma.TargetFuncAlways);

local function DamageFHIce(target, shot, source)
	local numShards = 7;
	local numSprites = 3;

	if (target.type == MT_FHZICE2)
		numShards = 10;
	end

	for i = 1,numShards
		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_FHZICE_SHARD;
		shard.frame = $1 + P_RandomKey(numSprites);
		shard.angle = P_RandomRange(0, 359) * ANG1;

		P_InstaThrust(shard, shard.angle, P_RandomRange(4, 6) * shard.scale);
		P_SetObjectMomZ(shard, P_RandomRange(6, 10) * FRACUNIT, false);

		if (shard.eflags & MFE_VERTICALFLIP)
			-- Just flip the sprite, not the gravity.
			shard.eflags = $1 & ~MFE_VERTICALFLIP;
			shard.flags2 = $1 & ~MF2_OBJECTFLIP;
			shard.renderflags = $1 | RF_VERTICALFLIP;
		end
	end

	P_KillMobj(target, shot, source);
	A_Scream(target, 0, 0);

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_FHZICE1, DamageFHIce);
Gamma.SetDamageFunc(MT_FHZICE2, DamageFHIce);
