//
// Bup edits
//

Gamma.SetTargetFunc(MT_SHELL, Gamma.TargetFuncAlways);

local function GammaHook_DamageKoopaShell(target, shot, source)
	// Kick that sucker around!
	if (target.movedir == 1)
		target.movedir = -1;
	else
		target.movedir = -1;
	end

	local a = R_PointToAngle2(shot.x - shot.momx, shot.y - shot.momy, target.x - target.momx, target.y - target.momy);
	P_InstaThrust(target, a, (target.info.speed * target.scale));
	S_StartSound(target, sfx_mario2);
	target.target = source;
	target.threshold = (3*TICRATE)/2;

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_SHELL, GammaHook_DamageKoopaShell);

Gamma.SetTargetFunc(MT_HAMMER, Gamma.TargetFuncAlways);
Gamma.SetDamageFunc(MT_HAMMER, Gamma.DamageFuncAlways);

local function GammaHook_TargetKoopa(mo, aimList, owner)
	if (mo.flags & MF_NOCLIPHEIGHT)
		// In custom Gamma death...
		return false;
	end

	// Always target.
	return true;
end

Gamma.SetTargetFunc(MT_KOOPA, GammaHook_TargetKoopa);

local function GammaHook_DamageKoopa(target, shot, source)
	if (target.flags & MF_NOCLIPHEIGHT)
		// In custom Gamma death...
		return Gamma.SHOT_EXPLODE;
	end

	// Act like axe was cut.
	target.momz = 5*FRACUNIT;

	// Go through the bridge.
	target.flags = ($1 | MF_NOCLIPHEIGHT) & ~(MF_PAIN);
	target.renderflags = $1 | RF_VERTICALFLIP;

	S_StartSound(target, sfx_mario1); // Closest thing srb2 has, lol

	// If it takes longer than this,
	// then there probably isn't any water
	// for them to fall into to begin with.
	target.fuse = 10*TICRATE;

	// This was successful damage.
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_KOOPA, GammaHook_DamageKoopa);

local function GammaHook_KoopaPoints(mo)
	return 1;
end

Gamma.SetPointsFunc(MT_KOOPA, GammaHook_KoopaPoints);

addHook("MobjThinker", function(koopa)
	if (koopa.flags & MF_NOCLIPHEIGHT)
		// Custom Gamma death animation
		if (koopa.watertop > koopa.z + koopa.height + (128*koopa.scale))
		and (koopa.health > 0)
			// Run the ceiling movement
			return false;
		end

		// Just do gravity
		koopa.momz = $1 + P_GetMobjGravity(koopa);
		P_MoveOrigin(koopa, koopa.x, koopa.y, koopa.z + koopa.momz);
		return true;
	end

	// Run as normal
	return false;
end, MT_KOOPA);
