//
// All da colors of the stalagmites
//

mobjinfo[MT_STALAGMITE0].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;
mobjinfo[MT_STALAGMITE1].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;
mobjinfo[MT_STALAGMITE2].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;
mobjinfo[MT_STALAGMITE3].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;
mobjinfo[MT_STALAGMITE4].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;
mobjinfo[MT_STALAGMITE5].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;
mobjinfo[MT_STALAGMITE6].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;
mobjinfo[MT_STALAGMITE7].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;
mobjinfo[MT_STALAGMITE8].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;
mobjinfo[MT_STALAGMITE9].flags = MF_NOTHINK|MF_NOCLIP|MF_SCENERY;

freeslot(
	"S_STALAGMITE_SHARD",
	"SPR_STGD",
	"SPR_ST2D",
	"SPR_ST3D",
	"SPR_ST4D",
	"SPR_ST5D"
);

states[S_STALAGMITE_SHARD] = {SPR_STGD, A, 35, nil, 0, 0, S_NULL};

Gamma.SetTargetFunc(MT_STALAGMITE0, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_STALAGMITE1, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_STALAGMITE2, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_STALAGMITE3, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_STALAGMITE4, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_STALAGMITE5, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_STALAGMITE6, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_STALAGMITE7, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_STALAGMITE8, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_STALAGMITE9, Gamma.TargetFuncAlways);

local function DamageGenericStalagmite(target, shot, source)
	local stalagOffset = target.type - MT_STALAGMITE0;
	local spriteOffset = stalagOffset / 2; // color
	local frameOffset = 0; // height
	local height = 48*FRACUNIT;

	if (stalagOffset & 1)
		frameOffset = $1 + 4;
		height = 32*FRACUNIT;
	end

	local shard = nil;
	local tossAngle = nil;
	local sign = nil;

	local shardList = {
		{spr = 0, mom = 4, z = 0, ang = ANGLE_22h},
		{spr = 1, mom = 4, z = 0, ang = -ANGLE_22h},
		{spr = 2, mom = 6, z = height, ang = ANGLE_11hh},
		{spr = 3, mom = 6, z = height, ang = -ANGLE_11hh},
	};

	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	for i = 1,#shardList
		local shardInfo = shardList[i];
		local tossAngle = origTossAngle + shardInfo.ang;

		local shard = P_SpawnMobjFromMobj(target, 0, 0, shardInfo.z, MT_BOSSJUNK);
		shard.state = S_STALAGMITE_SHARD;
		shard.sprite = $1 + spriteOffset;
		shard.frame = $1 + shardInfo.spr + frameOffset;
		shard.angle = tossAngle;

		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, shardInfo.mom * FRACUNIT, false);

		if (shard.eflags & MFE_VERTICALFLIP)
			-- Just flip the sprite, not the gravity.
			shard.eflags = $1 & ~MFE_VERTICALFLIP;
			shard.flags2 = $1 & ~MF2_OBJECTFLIP;
			shard.renderflags = $1 | RF_VERTICALFLIP;
		end

		if (i == 1)
			S_StartSound(shard, sfx_crumbl);
		end
	end

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_STALAGMITE0, DamageGenericStalagmite);
Gamma.SetDamageFunc(MT_STALAGMITE1, DamageGenericStalagmite);
Gamma.SetDamageFunc(MT_STALAGMITE2, DamageGenericStalagmite);
Gamma.SetDamageFunc(MT_STALAGMITE3, DamageGenericStalagmite);
Gamma.SetDamageFunc(MT_STALAGMITE4, DamageGenericStalagmite);
Gamma.SetDamageFunc(MT_STALAGMITE5, DamageGenericStalagmite);
Gamma.SetDamageFunc(MT_STALAGMITE6, DamageGenericStalagmite);
Gamma.SetDamageFunc(MT_STALAGMITE7, DamageGenericStalagmite);
Gamma.SetDamageFunc(MT_STALAGMITE8, DamageGenericStalagmite);
Gamma.SetDamageFunc(MT_STALAGMITE9, DamageGenericStalagmite);
