//
// Techno Hill flowers
//

mobjinfo[MT_THZFLOWER1].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_THZFLOWER2].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_THZFLOWER3].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_THZTREE].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_THZTREEBRANCH].flags = $1 & ~MF_NOBLOCKMAP;

freeslot(
	"S_TECHNOHILLSHARD",
	"SPR_THDB",

	"S_TECHNOHILLTREESHARD",
	"SPR_THTD",

	"S_THZTREE_DEAD",

	"MT_THZDUST",
	"S_THZDUST",
	"S_THZDUST2",
	"S_THZDUST3",
	"S_THZDUST4",
	"S_THZDUST5",
	"S_THZDUST6",
	"S_THZDUST7",
	"SPR_THDS",

	"sfx_cnglas",
	"S_ALARM_DEAD",
	"S_ALARM_SHARD1",
	"S_ALARM_SHARD2",
	"S_ALARM_SHARD3",
	"S_ALARM_SHARD4",
	"S_ALARM_SHARD5",
	"S_ALARM_SHARD6",
	"S_ALARM_SHARD7",
	"S_ALARM_SHARD8",
	"SPR_ALRD"
);

states[S_TECHNOHILLSHARD] = {SPR_THDB, A, 35, nil, 0, 0, S_NULL}
states[S_TECHNOHILLTREESHARD] = {SPR_THTD, B, 35, nil, 0, 0, S_NULL}

function A_DeadTHZTreeDust(actor, var1, var2)
	local dust = P_SpawnMobjFromMobj(actor,
		P_RandomRange(-2, 2) * FRACUNIT,
		P_RandomRange(-2, 2) * FRACUNIT,
		(22 + P_RandomRange(-2, 2)) * FRACUNIT,
		MT_THZDUST
	);

	dust.momx = P_RandomRange(-2, 2) * dust.scale;
	dust.momy = P_RandomRange(-2, 2) * dust.scale;
	dust.momz = ((6 + P_RandomRange(-2, 2)) * dust.scale) * P_MobjFlip(dust);
end

states[S_THZTREE_DEAD] = {SPR_THTD, A, 2, A_DeadTHZTreeDust, 0, 0, S_THZTREE_DEAD}

mobjinfo[MT_THZTREE].deathstate = S_THZTREE_DEAD;
mobjinfo[MT_THZTREE].deathsound = sfx_pop;

mobjinfo[MT_THZDUST] = {
	spawnstate = S_THZDUST,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY
}

states[S_THZDUST] = {SPR_THDS, A, 2, nil, 0, 0, S_THZDUST2}
states[S_THZDUST2] = {SPR_THDS, B, 1, nil, 0, 0, S_THZDUST3}
states[S_THZDUST3] = {SPR_THDS, C, 1, nil, 0, 0, S_THZDUST4}
states[S_THZDUST4] = {SPR_THDS, D, 1, nil, 0, 0, S_THZDUST5}
states[S_THZDUST5] = {SPR_THDS, E, 1, nil, 0, 0, S_THZDUST6}
states[S_THZDUST6] = {SPR_THDS, F, 1, nil, 0, 0, S_THZDUST7}
states[S_THZDUST7] = {SPR_THDS, G, 1, nil, 0, 0, S_NULL}

states[S_ALARM_DEAD] = {SPR_ALRD, A|FF_FULLBRIGHT, -1, nil, 0, 0, S_NULL}
states[S_ALARM_SHARD1] = {SPR_THDS, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_ALARM_SHARD2}
states[S_ALARM_SHARD2] = {SPR_THDS, C|FF_FULLBRIGHT, 2, nil, 0, 0, S_ALARM_SHARD3}
states[S_ALARM_SHARD3] = {SPR_THDS, D|FF_FULLBRIGHT, 2, nil, 0, 0, S_ALARM_SHARD4}
states[S_ALARM_SHARD4] = {SPR_THDS, E|FF_FULLBRIGHT, 2, nil, 0, 0, S_ALARM_SHARD5}
states[S_ALARM_SHARD5] = {SPR_THDS, F|FF_FULLBRIGHT, 2, nil, 0, 0, S_ALARM_SHARD6}
states[S_ALARM_SHARD6] = {SPR_THDS, E|FF_FULLBRIGHT, 2, nil, 0, 0, S_ALARM_SHARD7}
states[S_ALARM_SHARD7] = {SPR_THDS, D|FF_FULLBRIGHT, 2, nil, 0, 0, S_ALARM_SHARD8}
states[S_ALARM_SHARD8] = {SPR_THDS, C|FF_FULLBRIGHT, 2, nil, 0, 0, S_ALARM_SHARD1}

mobjinfo[MT_ALARM].deathstate = S_ALARM_DEAD;
mobjinfo[MT_ALARM].gammaTargetSize = mobjinfo[MT_ALARM].radius * 2;

Gamma.SetTargetFunc(MT_THZFLOWER1, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_THZFLOWER2, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_THZFLOWER3, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_THZTREE, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_ALARM, Gamma.TargetFuncAlways);

local function DamageSteamFlower(target, shot, source)
	local shard = nil;

	-- Flower top
	local shard = P_SpawnMobjFromMobj(target, 0, 0, 8*FRACUNIT, MT_BOSSJUNK);
	shard.state = S_TECHNOHILLSHARD;

	shard.angle = P_RandomRange(0, 359) * ANG1;
	P_InstaThrust(shard, shard.angle, 4 * shard.scale);
	P_SetObjectMomZ(shard, 6 * FRACUNIT, false);

	S_StartSound(shard, sfx_pop);

	-- Flower stem
	local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
	shard.state = S_TECHNOHILLSHARD;
	shard.frame = $1 + 1;

	shard.angle = P_RandomRange(0, 359) * ANG1;
	P_InstaThrust(shard, shard.angle, 4 * shard.scale);
	P_SetObjectMomZ(shard, 6 * FRACUNIT, false);

	-- Flower seed!
	local seed = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_SEED);
	seed.z = $1 + (P_MobjFlip(target) * (target.height - seed.height) / 2);
	seed.momz = 8 * seed.scale * P_MobjFlip(target);
	seed.angle = target.angle;

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_THZFLOWER1, DamageSteamFlower);

local function DamageSpinFlower(target, shot, source)
	local shard = nil;

	local stemFrame = P_RandomKey(2);
	local spawnZ = 0;

	-- Flower stem
	for i = 1,3
		local shard = P_SpawnMobjFromMobj(target, 0, 0, spawnZ, MT_BOSSJUNK);
		shard.state = S_TECHNOHILLSHARD;

		-- 0 then 1 then 0, or 1 then 0 then 1.
		shard.frame = $1 + 2 + stemFrame;
		stemFrame = $1 ^^ 1;

		shard.angle = P_RandomRange(0, 359) * ANG1;
		P_InstaThrust(shard, shard.angle, 4 * shard.scale);
		P_SetObjectMomZ(shard, 6 * FRACUNIT, false);

		spawnZ = $1 + 12*FRACUNIT;
	end

	-- Flower top
	local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
	shard.state = S_TECHNOHILLSHARD;

	if (target.type == MT_THZFLOWER3)
		shard.frame = $1 + 5;
	else
		shard.frame = $1 + 4;
	end

	shard.angle = P_RandomRange(0, 359) * ANG1;
	P_InstaThrust(shard, shard.angle, 4 * shard.scale);
	P_SetObjectMomZ(shard, 6 * FRACUNIT, false);

	S_StartSound(shard, sfx_pop);

	-- Flower seed!
	local seed = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_SEED);
	seed.z = $1 + (P_MobjFlip(target) * (target.height - seed.height) / 2);
	seed.momz = 8 * seed.scale * P_MobjFlip(target);
	seed.angle = target.angle;

	P_RemoveMobj(target);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_THZFLOWER2, DamageSpinFlower);
Gamma.SetDamageFunc(MT_THZFLOWER3, DamageSpinFlower);

local function DamageWhistleBush(target, shot, source)
	local shard = nil;
	local tossAngle = 0;
	local branchStartAngle = 0;

	shard = P_SpawnMobjFromMobj(target, 0, 0, 21*FRACUNIT, MT_BOSSJUNK);
	shard.state = S_TECHNOHILLTREESHARD;

	tossAngle = P_RandomRange(0, 359) * ANG1;
	P_InstaThrust(shard, tossAngle, 2 * shard.scale);
	P_SetObjectMomZ(shard, 8 * FRACUNIT, false);

	if (target.spawnpoint and target.spawnpoint.valid)
		branchStartAngle = FixedAngle((target.spawnpoint.angle % 113) << FRACBITS);
	else
		branchStartAngle = target.angle;
	end

	for i = 0,2
		local branchX = 0;
		local branchY = 0;
		local branchAngle = branchStartAngle;

		if (i == 0)
			branchX = FRACUNIT;
			branchAngle = $1 + ANGLE_22h;
		elseif (i == 1)
			branchY = FRACUNIT;
			branchAngle = $1 + ANGLE_157h;
		elseif (i == 2)
			branchX = -FRACUNIT;
			branchAngle = $1 + ANGLE_270;
		end

		shard = P_SpawnMobjFromMobj(target, branchX, branchY, 0, MT_BOSSJUNK);
		shard.state = S_TECHNOHILLTREESHARD;
		shard.frame = ($1 + 1) | FF_PAPERSPRITE;
		shard.angle = branchAngle;

		tossAngle = branchAngle + (P_RandomRange(-45, 45) * ANG1);
		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, 6 * FRACUNIT, false);

		local branchTwoX = branchX + P_ReturnThrustX(nil, branchAngle, 21 * FRACUNIT);
		local branchTwoY = branchY + P_ReturnThrustY(nil, branchAngle, 21 * FRACUNIT);

		shard = P_SpawnMobjFromMobj(target, branchTwoX, branchTwoY, 0, MT_BOSSJUNK);
		shard.state = S_TECHNOHILLTREESHARD;
		shard.frame = ($1 + 2) | FF_PAPERSPRITE;
		shard.angle = branchAngle;

		tossAngle = branchAngle + (P_RandomRange(-45, 45) * ANG1);
		P_InstaThrust(shard, tossAngle, 4 * shard.scale);
		P_SetObjectMomZ(shard, 6 * FRACUNIT, false);

		-- Flower seed!
		local seed = P_SpawnMobjFromMobj(target, branchX, branchY, 0, MT_SEED);
		seed.z = $1 + (P_MobjFlip(target) * (target.height - seed.height) / 2);
		seed.momz = 8 * seed.scale * P_MobjFlip(target);
		seed.angle = branchAngle;
		P_InstaThrust(seed, seed.angle, seed.scale);

		branchAngle = $1 + ANGLE_135;
	end

	A_Scream(target, 0, 0);
	P_KillMobj(target, shot, source);

	-- Find attached branches & destroy.
	local branches = Gamma.FindAttachedObjects(target, MT_THZTREEBRANCH);
	for _,v in pairs(branches) do
		if (v and v.valid)
			P_RemoveMobj(v);
		end
	end

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_THZTREE, DamageWhistleBush);

local function DamageAlarm(target, shot, source)
	for i = 1,8 do
		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_ALARM_SHARD1;

		shard.angle = P_RandomRange(0, 359) * ANG1;
		P_InstaThrust(shard, shard.angle, 4 * shard.scale);
		P_SetObjectMomZ(shard, P_RandomRange(-2, 2) * FRACUNIT, false);

		shard.rollangle = P_RandomRange(0, 359) * ANG1;
		shard.fuse = TICRATE;
	end

	S_StartSound(target, sfx_cnglas);
	P_KillMobj(target, shot, source);

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_ALARM, DamageAlarm);
