//
// The Grinch (played by Jim Carrey) roleplay
//

mobjinfo[MT_XMASPOLE].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_CANDYCANE].flags = $1 & ~MF_NOBLOCKMAP;
mobjinfo[MT_HANGSTAR].flags = $1 & ~MF_NOBLOCKMAP;

freeslot(
	"S_XMASPOLE_SHARD",
	"S_XMASPOLE_DEAD",
	"SPR_XM1D",

	"S_CANDYCANE_SHARD",
	"S_CANDYCANE_DEAD",
	"SPR_XM2D",

	"MT_SNOWMAN_CHUNK_HEAD",
	"S_SNOWMAN_CHUNK",
	"S_SNOWMAN_CHUNK_HEAD",
	"S_SNOWMAN_CHUNK_ARM",
	"S_SNOWMAN_CHUNK_HAT",
	"S_SNOWMAN_CHUNK_SCARF",
	"SPR_XM3D",

	"S_LAMPPOST_SHARD",
	"S_LAMPPOST1_DEAD",
	"S_LAMPPOST2_DEAD",
	"SPR_XM4D",

	"S_HANGSTAR_SHARD",
	"S_HANGSTAR_SHARD2",
	"S_HANGSTAR_SHARD3",
	"S_HANGSTAR_SHARD4",
	"S_HANGSTAR_SHARD5",
	"S_HANGSTAR_SHARD6",
	"S_HANGSTAR_SHARD7",
	"S_HANGSTAR_SHARD8",
	"S_HANGSTAR_DEAD",
	"SPR_XM5D"
);

states[S_XMASPOLE_SHARD] = {SPR_XM1D, A, 35, nil, 0, 0, S_NULL};
states[S_XMASPOLE_DEAD] = {SPR_XM1D, B, -1, nil, 0, 0, S_NULL};

mobjinfo[MT_XMASPOLE].deathstate = S_XMASPOLE_DEAD;
mobjinfo[MT_XMASPOLE].deathsound = sfx_s3k96;

states[S_CANDYCANE_SHARD] = {SPR_XM2D, A, 35, nil, 0, 0, S_NULL};
states[S_CANDYCANE_DEAD] = {SPR_XM2D, B, -1, nil, 0, 0, S_NULL};

mobjinfo[MT_CANDYCANE].deathstate = S_CANDYCANE_DEAD;
mobjinfo[MT_CANDYCANE].deathsound = sfx_s3k96;

mobjinfo[MT_SNOWMAN_CHUNK_HEAD] = {
	spawnstate = S_SNOWMAN_CHUNK_HEAD,
	spawnhealth = 1000,
	radius = 12*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_BOUNCE
};

states[S_SNOWMAN_CHUNK] = {SPR_XM3D, A, 35, nil, 0, 0, S_NULL};
states[S_SNOWMAN_CHUNK_HEAD] = {SPR_XM3D, B, -1, nil, 0, 0, S_NULL};
states[S_SNOWMAN_CHUNK_ARM] = {SPR_XM3D, C, 35, nil, 0, 0, S_NULL};
states[S_SNOWMAN_CHUNK_HAT] = {SPR_XM3D, D, 35, nil, 0, 0, S_NULL};
states[S_SNOWMAN_CHUNK_SCARF] = {SPR_XM3D, E, 35, nil, 0, 0, S_NULL};

states[S_LAMPPOST_SHARD] = {SPR_XM4D, C, 35, nil, 0, 0, S_NULL};
states[S_LAMPPOST1_DEAD] = {SPR_XM4D, A, -1, nil, 0, 0, S_NULL};
states[S_LAMPPOST2_DEAD] = {SPR_XM4D, B, -1, nil, 0, 0, S_NULL};

mobjinfo[MT_LAMPPOST1].deathstate = S_LAMPPOST1_DEAD;
mobjinfo[MT_LAMPPOST1].deathsound = sfx_s3k96;

mobjinfo[MT_LAMPPOST2].deathstate = S_LAMPPOST2_DEAD;
mobjinfo[MT_LAMPPOST2].deathsound = sfx_s3k96;

states[S_HANGSTAR_SHARD] = {SPR_XM5D, A, 2, nil, 0, 0, S_HANGSTAR_SHARD2};
states[S_HANGSTAR_SHARD2] = {SPR_XM5D, B, 2, nil, 0, 0, S_HANGSTAR_SHARD3};
states[S_HANGSTAR_SHARD3] = {SPR_XM5D, C, 2, nil, 0, 0, S_HANGSTAR_SHARD4};
states[S_HANGSTAR_SHARD4] = {SPR_XM5D, D, 2, nil, 0, 0, S_HANGSTAR_SHARD5};
states[S_HANGSTAR_SHARD5] = {SPR_XM5D, E, 2, nil, 0, 0, S_HANGSTAR_SHARD6};
states[S_HANGSTAR_SHARD6] = {SPR_XM5D, D, 2, nil, 0, 0, S_HANGSTAR_SHARD7};
states[S_HANGSTAR_SHARD7] = {SPR_XM5D, C, 2, nil, 0, 0, S_HANGSTAR_SHARD8};
states[S_HANGSTAR_SHARD8] = {SPR_XM5D, B, 2, nil, 0, 0, S_HANGSTAR_SHARD};

states[S_HANGSTAR_DEAD] = {SPR_XM5D, F, -1, nil, 0, 0, S_NULL};

mobjinfo[MT_HANGSTAR].deathstate = S_HANGSTAR_DEAD;
mobjinfo[MT_HANGSTAR].deathsound = sfx_cnglas;

Gamma.SetTargetFunc(MT_XMASPOLE, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_CANDYCANE, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_SNOWMAN, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_SNOWMANHAT, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_LAMPPOST1, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_LAMPPOST2, Gamma.TargetFuncAlways);
Gamma.SetTargetFunc(MT_HANGSTAR, Gamma.TargetFuncAlways);

local function DamageXmasPole(target, shot, source)
	local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
	shard.state = S_XMASPOLE_SHARD;
	shard.angle = P_RandomRange(0, 359) * ANG1;

	P_InstaThrust(shard, shard.angle, 4 * shard.scale);
	P_SetObjectMomZ(shard, 8 * FRACUNIT, false);

	P_KillMobj(target, shot, source);
	A_Scream(target, 0, 0);

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_XMASPOLE, DamageXmasPole);

local function DamageCandyCane(target, shot, source)
	local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
	shard.state = S_CANDYCANE_SHARD;
	shard.angle = P_RandomRange(0, 359) * ANG1;

	P_InstaThrust(shard, shard.angle, 4 * shard.scale);
	P_SetObjectMomZ(shard, 6 * FRACUNIT, false);

	P_KillMobj(target, shot, source);
	A_Scream(target, 0, 0);

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_CANDYCANE, DamageCandyCane);

local function SnowChunks(mo, dir)
	local numShards = 4;
	for i = 1,numShards do
		local shard = P_SpawnMobjFromMobj(mo, 0, 0, 16*FRACUNIT, MT_BOSSJUNK);
		shard.state = S_SNOWMAN_CHUNK;

		if (dir != nil)
			shard.angle = dir + (P_RandomRange(-45, 45) * ANG1);
		else
			shard.angle = P_RandomRange(0, 359) * ANG1;
		end

		P_InstaThrust(shard, shard.angle, 4 * shard.scale);
		P_SetObjectMomZ(shard, P_RandomRange(4, 8) * FRACUNIT, false);
	end

	P_RemoveMobj(mo);
end

addHook("MobjThinker", function(mo)
	local flip = P_MobjFlip(mo);
	if (mo.momz * flip <= 0)
	and (P_IsObjectOnGround(mo) == true)
		-- spawn chunks
		SnowChunks(mo, nil);
		return;
	end
end, MT_SNOWMAN_CHUNK_HEAD);

local function DamageSnowman(target, shot, source)
	local shard = nil;
	local origTossAngle = R_PointToAngle2(shot.x, shot.y, target.x, target.y);

	-- Head
	shard = P_SpawnMobjFromMobj(target, 0, 0, 36*FRACUNIT, MT_SNOWMAN_CHUNK_HEAD);
	shard.angle = P_RandomRange(0, 359) * ANG1;

	P_InstaThrust(shard, shard.angle, 1 * shard.scale);
	P_SetObjectMomZ(shard, 10 * FRACUNIT, false);

	-- Arms
	for i = 0,1 do
		local sideAngle = origTossAngle;
		if (i & 1)
			sideAngle = $1 + ANGLE_90;
		else
			sideAngle = $1 - ANGLE_90;
		end

		shard = P_SpawnMobjFromMobj(target, 24 * cos(sideAngle), 24 * sin(sideAngle), 32*FRACUNIT, MT_BOSSJUNK);
		shard.state = S_SNOWMAN_CHUNK_ARM;
		shard.angle = sideAngle;

		P_InstaThrust(shard, origTossAngle, 2 * shard.scale);
		P_Thrust(shard, shard.angle, 3 * shard.scale);

		P_SetObjectMomZ(shard, 4 * FRACUNIT, false);
	end

	if (target.type == MT_SNOWMANHAT)
		-- Hat
		shard = P_SpawnMobjFromMobj(target, 0, 0, 60*FRACUNIT, MT_BOSSJUNK);
		shard.state = S_SNOWMAN_CHUNK_HAT;
		shard.angle = P_RandomRange(0, 359) * ANG1;

		P_InstaThrust(shard, origTossAngle, 5 * shard.scale);
		P_Thrust(shard, shard.angle, 6 * shard.scale);

		P_SetObjectMomZ(shard, 14 * FRACUNIT, false);

		-- Scarf
		shard = P_SpawnMobjFromMobj(target, 0, 0, 32*FRACUNIT, MT_BOSSJUNK);
		shard.state = S_SNOWMAN_CHUNK_SCARF;
		shard.angle = P_RandomRange(0, 359) * ANG1;
		shard.flags = $1 | MF_NOGRAVITY;

		P_InstaThrust(shard, origTossAngle, 4 * shard.scale);
		P_Thrust(shard, shard.angle, 4 * shard.scale);

		P_SetObjectMomZ(shard, 4 * FRACUNIT, false);
	end

	SnowChunks(target, origTossAngle);
	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_SNOWMAN, DamageSnowman);
Gamma.SetDamageFunc(MT_SNOWMANHAT, DamageSnowman);

local function DamageXmasLamp(target, shot, source)
	local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
	shard.state = S_LAMPPOST_SHARD;
	shard.angle = P_RandomRange(0, 359) * ANG1;

	P_InstaThrust(shard, shard.angle, 4 * shard.scale);
	P_SetObjectMomZ(shard, 4 * FRACUNIT, false);

	P_KillMobj(target, shot, source);
	A_Scream(target, 0, 0);

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_LAMPPOST1, DamageXmasLamp);
Gamma.SetDamageFunc(MT_LAMPPOST2, DamageXmasLamp);

local function DamageHangingStar(target, shot, source)
	local numShards = 5;
	for i = 1,numShards
		local shard = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_BOSSJUNK);
		shard.state = S_HANGSTAR_SHARD;
		shard.angle = P_RandomRange(0, 359) * ANG1;
		shard.fuse = TICRATE;

		P_InstaThrust(shard, shard.angle, 4 * shard.scale);
		P_SetObjectMomZ(shard, P_RandomRange(-2, 2) * FRACUNIT, false);
	end

	P_KillMobj(target, shot, source);
	A_Scream(target, 0, 0);

	return Gamma.SHOT_EXPLODE;
end

Gamma.SetDamageFunc(MT_HANGSTAR, DamageHangingStar);
